<?php
error_reporting(E_ERROR);
// error_reporting(E_ALL);

session_start();
$sessionLifeTime = 60*60*48;
ini_set('memory_limit', -1);
ini_set('max_execution_time', 600);
ini_set('session.gc_maxlifetime', $sessionLifeTime);
ini_set('session.cookie_lifetime', $sessionLifeTime);


if ( !empty($_POST))
{
    $dbImport = array(
        'dbImportHost' => $_POST['dbImportHost'],
        'dbImportName' => $_POST['dbImportName'],
        'dbImportUsername' => $_POST['dbImportUsername'],
        'dbImportPassword' => $_POST['dbImportPassword'],
        'dbImportTablePrefix' => $_POST['dbImportTablePrefix'],
    );

    $dbExport = array(
        'dbExportHost' => $_POST['dbExportHost'],
        'dbExportName' => $_POST['dbExportName'],
        'dbExportUsername' => $_POST['dbExportUsername'],
        'dbExportPassword' => $_POST['dbExportPassword'],
        'dbExportTablePrefix' => $_POST['dbExportTablePrefix'],
    );

    // Импорт + экспорт
    if (isset($_POST['importControl']))
    {
        $controlModel = new ImportControlModel($dbImport,$dbExport);
        $controlController = new ImportControlController($controlModel);
        $controlOK = $controlController->import();
    }
    // Импорт + экспорт
    elseif (isset($_POST['importPosition']))
    {
        $positionModel = new ImportPositionModel($dbImport,$dbExport);
        $positionController = new ImportPositionController($positionModel);
        $positionOK = $positionController->import();
    }
    // Чистим таблицы для экспорта
    elseif (isset($_POST['clearExport']))
    {
        $importModel = new ImportModel($dbImport,$dbExport);
        $importModel->truncateExportTables();
    }
    
    $errorMSG = ImportModel::getErrorMSG();
}

?>
<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"/>
        <meta name="language" content="ru" />

        <style>.clearfix{*zoom:1;}.clearfix:before,.clearfix:after{display:table;content:"";line-height:0;}
            .clearfix:after{clear:both;}
            .hide-text{font:0/0 a;color:transparent;text-shadow:none;background-color:transparent;border:0;}
            .input-block-level{display:block;width:100%;min-height:30px;-webkit-box-sizing:border-box;-moz-box-sizing:border-box;box-sizing:border-box;}
            article,aside,details,figcaption,figure,footer,header,hgroup,nav,section{display:block;}
            audio,canvas,video{display:inline-block;*display:inline;*zoom:1;}
            audio:not([controls]){display:none;}
            html{font-size:100%;-webkit-text-size-adjust:100%;-ms-text-size-adjust:100%;}
            a:focus{outline:thin dotted #333;outline:5px auto -webkit-focus-ring-color;outline-offset:-2px;}
            a:hover,a:active{outline:0;}
            sub,sup{position:relative;font-size:75%;line-height:0;vertical-align:baseline;}
            sup{top:-0.5em;}
            sub{bottom:-0.25em;}
            img{max-width:100%;width:auto\9;height:auto;vertical-align:middle;border:0;-ms-interpolation-mode:bicubic;}
            #map_canvas img,.google-maps img{max-width:none;}
            button,input,select,textarea{margin:0;font-size:100%;vertical-align:middle;}
            button,input{*overflow:visible;line-height:normal;}
            button::-moz-focus-inner,input::-moz-focus-inner{padding:0;border:0;}
            button,html input[type="button"],input[type="reset"],input[type="submit"]{-webkit-appearance:button;cursor:pointer;}
            label,select,button,input[type="button"],input[type="reset"],input[type="submit"],input[type="radio"],input[type="checkbox"]{cursor:pointer;}
            input[type="search"]{-webkit-box-sizing:content-box;-moz-box-sizing:content-box;box-sizing:content-box;-webkit-appearance:textfield;}
            input[type="search"]::-webkit-search-decoration,input[type="search"]::-webkit-search-cancel-button{-webkit-appearance:none;}
            textarea{overflow:auto;vertical-align:top;}
            @media print{*{text-shadow:none !important;color:#000 !important;background:transparent !important;box-shadow:none !important;} a,a:visited{text-decoration:underline;} a[href]:after{content:" (" attr(href) ")";} abbr[title]:after{content:" (" attr(title) ")";} .ir a:after,a[href^="javascript:"]:after,a[href^="#"]:after{content:"";} pre,blockquote{border:1px solid #999;page-break-inside:avoid;} thead{display:table-header-group;} tr,img{page-break-inside:avoid;} img{max-width:100% !important;} @page {margin:0.5cm;}p,h2,h3{orphans:3;widows:3;} h2,h3{page-break-after:avoid;}}body{margin:0;font-family:"Helvetica Neue",Helvetica,Arial,sans-serif;font-size:14px;line-height:20px;color:#333333;background-color:#ffffff;}
            a{color:#0088cc;text-decoration:none;}
            a:hover,a:focus{color:#005580;text-decoration:underline;}
            .img-rounded{-webkit-border-radius:6px;-moz-border-radius:6px;border-radius:6px;}
            .img-polaroid{padding:4px;background-color:#fff;border:1px solid #ccc;border:1px solid rgba(0, 0, 0, 0.2);-webkit-box-shadow:0 1px 3px rgba(0, 0, 0, 0.1);-moz-box-shadow:0 1px 3px rgba(0, 0, 0, 0.1);box-shadow:0 1px 3px rgba(0, 0, 0, 0.1);}
            .img-circle{-webkit-border-radius:500px;-moz-border-radius:500px;border-radius:500px;}
            .row{margin-left:-20px;*zoom:1;}.row:before,.row:after{display:table;content:"";line-height:0;}
            .row:after{clear:both;}
            [class*="span"]{float:left;min-height:1px;margin-left:20px;}
            .container,.navbar-static-top .container,.navbar-fixed-top .container,.navbar-fixed-bottom .container{width:940px;}
            .span12{width:940px;}
            .span11{width:860px;}
            .span10{width:780px;}
            .span9{width:700px;}
            .span8{width:620px;}
            .span7{width:540px;}
            .span6{width:460px;}
            .span5{width:380px;}
            .span4{width:300px;}
            .span3{width:220px;}
            .span2{width:140px;}
            .span1{width:60px;}
            .offset12{margin-left:980px;}
            .offset11{margin-left:900px;}
            .offset10{margin-left:820px;}
            .offset9{margin-left:740px;}
            .offset8{margin-left:660px;}
            .offset7{margin-left:580px;}
            .offset6{margin-left:500px;}
            .offset5{margin-left:420px;}
            .offset4{margin-left:340px;}
            .offset3{margin-left:260px;}
            .offset2{margin-left:180px;}
            .offset1{margin-left:100px;}
            .row-fluid{width:100%;*zoom:1;}.row-fluid:before,.row-fluid:after{display:table;content:"";line-height:0;}
            .row-fluid:after{clear:both;}
            .row-fluid [class*="span"]{display:block;width:100%;min-height:30px;-webkit-box-sizing:border-box;-moz-box-sizing:border-box;box-sizing:border-box;float:left;margin-left:2.127659574468085%;*margin-left:2.074468085106383%;}
            .row-fluid [class*="span"]:first-child{margin-left:0;}
            .row-fluid .controls-row [class*="span"]+[class*="span"]{margin-left:2.127659574468085%;}
            .row-fluid .span12{width:100%;*width:99.94680851063829%;}
            .row-fluid .span11{width:91.48936170212765%;*width:91.43617021276594%;}
            .row-fluid .span10{width:82.97872340425532%;*width:82.92553191489361%;}
            .row-fluid .span9{width:74.46808510638297%;*width:74.41489361702126%;}
            .row-fluid .span8{width:65.95744680851064%;*width:65.90425531914893%;}
            .row-fluid .span7{width:57.44680851063829%;*width:57.39361702127659%;}
            .row-fluid .span6{width:48.93617021276595%;*width:48.88297872340425%;}
            .row-fluid .span5{width:40.42553191489362%;*width:40.37234042553192%;}
            .row-fluid .span4{width:31.914893617021278%;*width:31.861702127659576%;}
            .row-fluid .span3{width:23.404255319148934%;*width:23.351063829787233%;}
            .row-fluid .span2{width:14.893617021276595%;*width:14.840425531914894%;}
            .row-fluid .span1{width:6.382978723404255%;*width:6.329787234042553%;}
            .row-fluid .offset12{margin-left:104.25531914893617%;*margin-left:104.14893617021275%;}
            .row-fluid .offset12:first-child{margin-left:102.12765957446808%;*margin-left:102.02127659574467%;}
            .row-fluid .offset11{margin-left:95.74468085106382%;*margin-left:95.6382978723404%;}
            .row-fluid .offset11:first-child{margin-left:93.61702127659574%;*margin-left:93.51063829787232%;}
            .row-fluid .offset10{margin-left:87.23404255319149%;*margin-left:87.12765957446807%;}
            .row-fluid .offset10:first-child{margin-left:85.1063829787234%;*margin-left:84.99999999999999%;}
            .row-fluid .offset9{margin-left:78.72340425531914%;*margin-left:78.61702127659572%;}
            .row-fluid .offset9:first-child{margin-left:76.59574468085106%;*margin-left:76.48936170212764%;}
            .row-fluid .offset8{margin-left:70.2127659574468%;*margin-left:70.10638297872339%;}
            .row-fluid .offset8:first-child{margin-left:68.08510638297872%;*margin-left:67.9787234042553%;}
            .row-fluid .offset7{margin-left:61.70212765957446%;*margin-left:61.59574468085106%;}
            .row-fluid .offset7:first-child{margin-left:59.574468085106375%;*margin-left:59.46808510638297%;}
            .row-fluid .offset6{margin-left:53.191489361702125%;*margin-left:53.085106382978715%;}
            .row-fluid .offset6:first-child{margin-left:51.063829787234035%;*margin-left:50.95744680851063%;}
            .row-fluid .offset5{margin-left:44.68085106382979%;*margin-left:44.57446808510638%;}
            .row-fluid .offset5:first-child{margin-left:42.5531914893617%;*margin-left:42.4468085106383%;}
            .row-fluid .offset4{margin-left:36.170212765957444%;*margin-left:36.06382978723405%;}
            .row-fluid .offset4:first-child{margin-left:34.04255319148936%;*margin-left:33.93617021276596%;}
            .row-fluid .offset3{margin-left:27.659574468085104%;*margin-left:27.5531914893617%;}
            .row-fluid .offset3:first-child{margin-left:25.53191489361702%;*margin-left:25.425531914893618%;}
            .row-fluid .offset2{margin-left:19.148936170212764%;*margin-left:19.04255319148936%;}
            .row-fluid .offset2:first-child{margin-left:17.02127659574468%;*margin-left:16.914893617021278%;}
            .row-fluid .offset1{margin-left:10.638297872340425%;*margin-left:10.53191489361702%;}
            .row-fluid .offset1:first-child{margin-left:8.51063829787234%;*margin-left:8.404255319148938%;}
            [class*="span"].hide,.row-fluid [class*="span"].hide{display:none;}
            [class*="span"].pull-right,.row-fluid [class*="span"].pull-right{float:right;}
            .container{margin-right:auto;margin-left:auto;*zoom:1;}.container:before,.container:after{display:table;content:"";line-height:0;}
            .container:after{clear:both;}
            .container-fluid{padding-right:20px;padding-left:20px;*zoom:1;}.container-fluid:before,.container-fluid:after{display:table;content:"";line-height:0;}
            .container-fluid:after{clear:both;}
            p{margin:0 0 10px;}
            .lead{margin-bottom:20px;font-size:21px;font-weight:200;line-height:30px;}
            small{font-size:85%;}
            strong{font-weight:bold;}
            em{font-style:italic;}
            cite{font-style:normal;}
            .muted{color:#999999;}
            a.muted:hover,a.muted:focus{color:#808080;}
            .text-warning{color:#c09853;}
            a.text-warning:hover,a.text-warning:focus{color:#a47e3c;}
            .text-error{color:#b94a48;}
            a.text-error:hover,a.text-error:focus{color:#953b39;}
            .text-info{color:#3a87ad;}
            a.text-info:hover,a.text-info:focus{color:#2d6987;}
            .text-success{color:#468847;}
            a.text-success:hover,a.text-success:focus{color:#356635;}
            .text-left{text-align:left;}
            .text-right{text-align:right;}
            .text-center{text-align:center;}
            h1,h2,h3,h4,h5,h6{margin:10px 0;font-family:inherit;font-weight:bold;line-height:20px;color:inherit;text-rendering:optimizelegibility;}h1 small,h2 small,h3 small,h4 small,h5 small,h6 small{font-weight:normal;line-height:1;color:#999999;}
            h1,h2,h3{line-height:40px;}
            h1{font-size:38.5px;}
            h2{font-size:31.5px;}
            h3{font-size:24.5px;}
            h4{font-size:17.5px;}
            h5{font-size:14px;}
            h6{font-size:11.9px;}
            h1 small{font-size:24.5px;}
            h2 small{font-size:17.5px;}
            h3 small{font-size:14px;}
            h4 small{font-size:14px;}
            .page-header{padding-bottom:9px;margin:20px 0 30px;border-bottom:1px solid #eeeeee;}
            ul,ol{padding:0;margin:0 0 10px 25px;}
            ul ul,ul ol,ol ol,ol ul{margin-bottom:0;}
            li{line-height:20px;}
            ul.unstyled,ol.unstyled{margin-left:0;list-style:none;}
            ul.inline,ol.inline{margin-left:0;list-style:none;}ul.inline>li,ol.inline>li{display:inline-block;*display:inline;*zoom:1;padding-left:5px;padding-right:5px;}
            dl{margin-bottom:20px;}
            dt,dd{line-height:20px;}
            dt{font-weight:bold;}
            dd{margin-left:10px;}
            .dl-horizontal{*zoom:1;}.dl-horizontal:before,.dl-horizontal:after{display:table;content:"";line-height:0;}
            .dl-horizontal:after{clear:both;}
            .dl-horizontal dt{float:left;width:160px;clear:left;text-align:right;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;}
            .dl-horizontal dd{margin-left:180px;}
            hr{margin:20px 0;border:0;border-top:1px solid #eeeeee;border-bottom:1px solid #ffffff;}
            abbr[title],abbr[data-original-title]{cursor:help;border-bottom:1px dotted #999999;}
            abbr.initialism{font-size:90%;text-transform:uppercase;}
            blockquote{padding:0 0 0 15px;margin:0 0 20px;border-left:5px solid #eeeeee;}blockquote p{margin-bottom:0;font-size:17.5px;font-weight:300;line-height:1.25;}
            blockquote small{display:block;line-height:20px;color:#999999;}blockquote small:before{content:'\2014 \00A0';}
            blockquote.pull-right{float:right;padding-right:15px;padding-left:0;border-right:5px solid #eeeeee;border-left:0;}blockquote.pull-right p,blockquote.pull-right small{text-align:right;}
            blockquote.pull-right small:before{content:'';}
            blockquote.pull-right small:after{content:'\00A0 \2014';}
            q:before,q:after,blockquote:before,blockquote:after{content:"";}
            address{display:block;margin-bottom:20px;font-style:normal;line-height:20px;}
            .label,.badge{display:inline-block;padding:2px 4px;font-size:11.844px;font-weight:bold;line-height:14px;color:#ffffff;vertical-align:baseline;white-space:nowrap;text-shadow:0 -1px 0 rgba(0, 0, 0, 0.25);background-color:#999999;}
            .label{-webkit-border-radius:3px;-moz-border-radius:3px;border-radius:3px;}
            .badge{padding-left:9px;padding-right:9px;-webkit-border-radius:9px;-moz-border-radius:9px;border-radius:9px;}
            .label:empty,.badge:empty{display:none;}
            a.label:hover,a.label:focus,a.badge:hover,a.badge:focus{color:#ffffff;text-decoration:none;cursor:pointer;}
            .label-important,.badge-important{background-color:#b94a48;}
            .label-important[href],.badge-important[href]{background-color:#953b39;}
            .label-warning,.badge-warning{background-color:#f89406;}
            .label-warning[href],.badge-warning[href]{background-color:#c67605;}
            .label-success,.badge-success{background-color:#468847;}
            .label-success[href],.badge-success[href]{background-color:#356635;}
            .label-info,.badge-info{background-color:#3a87ad;}
            .label-info[href],.badge-info[href]{background-color:#2d6987;}
            .label-inverse,.badge-inverse{background-color:#333333;}
            .label-inverse[href],.badge-inverse[href]{background-color:#1a1a1a;}
            .btn .label,.btn .badge{position:relative;top:-1px;}
            .btn-mini .label,.btn-mini .badge{top:0;}
            form{margin:0 0 20px;}
            fieldset{padding:0;margin:0;border:0;}
            legend{display:block;width:100%;padding:0;margin-bottom:20px;font-size:21px;line-height:40px;color:#333333;border:0;border-bottom:1px solid #e5e5e5;}legend small{font-size:15px;color:#999999;}
            label,input,button,select,textarea{font-size:14px;font-weight:normal;line-height:20px;}
            input,button,select,textarea{font-family:"Helvetica Neue",Helvetica,Arial,sans-serif;}
            label{display:block;margin-bottom:5px;}
            select,textarea,input[type="text"],input[type="password"],input[type="datetime"],input[type="datetime-local"],input[type="date"],input[type="month"],input[type="time"],input[type="week"],input[type="number"],input[type="email"],input[type="url"],input[type="search"],input[type="tel"],input[type="color"],.uneditable-input{display:inline-block;height:20px;padding:4px 6px;margin-bottom:10px;font-size:14px;line-height:20px;color:#555555;-webkit-border-radius:4px;-moz-border-radius:4px;border-radius:4px;vertical-align:middle;}
            input,textarea,.uneditable-input{width:206px;}
            textarea{height:auto;}
            textarea,input[type="text"],input[type="password"],input[type="datetime"],input[type="datetime-local"],input[type="date"],input[type="month"],input[type="time"],input[type="week"],input[type="number"],input[type="email"],input[type="url"],input[type="search"],input[type="tel"],input[type="color"],.uneditable-input{background-color:#ffffff;border:1px solid #cccccc;-webkit-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075);-moz-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075);box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075);-webkit-transition:border linear .2s, box-shadow linear .2s;-moz-transition:border linear .2s, box-shadow linear .2s;-o-transition:border linear .2s, box-shadow linear .2s;transition:border linear .2s, box-shadow linear .2s;}textarea:focus,input[type="text"]:focus,input[type="password"]:focus,input[type="datetime"]:focus,input[type="datetime-local"]:focus,input[type="date"]:focus,input[type="month"]:focus,input[type="time"]:focus,input[type="week"]:focus,input[type="number"]:focus,input[type="email"]:focus,input[type="url"]:focus,input[type="search"]:focus,input[type="tel"]:focus,input[type="color"]:focus,.uneditable-input:focus{border-color:rgba(82, 168, 236, 0.8);outline:0;outline:thin dotted \9;-webkit-box-shadow:inset 0 1px 1px rgba(0,0,0,.075), 0 0 8px rgba(82,168,236,.6);-moz-box-shadow:inset 0 1px 1px rgba(0,0,0,.075), 0 0 8px rgba(82,168,236,.6);box-shadow:inset 0 1px 1px rgba(0,0,0,.075), 0 0 8px rgba(82,168,236,.6);}
            input[type="radio"],input[type="checkbox"]{margin:4px 0 0;*margin-top:0;margin-top:1px \9;line-height:normal;}
            input[type="file"],input[type="image"],input[type="submit"],input[type="reset"],input[type="button"],input[type="radio"],input[type="checkbox"]{width:auto;}
            select,input[type="file"]{height:30px;*margin-top:4px;line-height:30px;}
            select{width:220px;border:1px solid #cccccc;background-color:#ffffff;}
            select[multiple],select[size]{height:auto;}
            select:focus,input[type="file"]:focus,input[type="radio"]:focus,input[type="checkbox"]:focus{outline:thin dotted #333;outline:5px auto -webkit-focus-ring-color;outline-offset:-2px;}
            .uneditable-input,.uneditable-textarea{color:#999999;background-color:#fcfcfc;border-color:#cccccc;-webkit-box-shadow:inset 0 1px 2px rgba(0, 0, 0, 0.025);-moz-box-shadow:inset 0 1px 2px rgba(0, 0, 0, 0.025);box-shadow:inset 0 1px 2px rgba(0, 0, 0, 0.025);cursor:not-allowed;}
            .uneditable-input{overflow:hidden;white-space:nowrap;}
            .uneditable-textarea{width:auto;height:auto;}
            input:-moz-placeholder,textarea:-moz-placeholder{color:#999999;}
            input:-ms-input-placeholder,textarea:-ms-input-placeholder{color:#999999;}
            input::-webkit-input-placeholder,textarea::-webkit-input-placeholder{color:#999999;}
            .radio,.checkbox{min-height:20px;padding-left:20px;}
            .radio input[type="radio"],.checkbox input[type="checkbox"]{float:left;margin-left:-20px;}
            .controls>.radio:first-child,.controls>.checkbox:first-child{padding-top:5px;}
            .radio.inline,.checkbox.inline{display:inline-block;padding-top:5px;margin-bottom:0;vertical-align:middle;}
            .radio.inline+.radio.inline,.checkbox.inline+.checkbox.inline{margin-left:10px;}
            .input-mini{width:60px;}
            .input-small{width:90px;}
            .input-medium{width:150px;}
            .input-large{width:210px;}
            .input-xlarge{width:270px;}
            .input-xxlarge{width:530px;}
            input[class*="span"],select[class*="span"],textarea[class*="span"],.uneditable-input[class*="span"],.row-fluid input[class*="span"],.row-fluid select[class*="span"],.row-fluid textarea[class*="span"],.row-fluid .uneditable-input[class*="span"]{float:none;margin-left:0;}
            .input-append input[class*="span"],.input-append .uneditable-input[class*="span"],.input-prepend input[class*="span"],.input-prepend .uneditable-input[class*="span"],.row-fluid input[class*="span"],.row-fluid select[class*="span"],.row-fluid textarea[class*="span"],.row-fluid .uneditable-input[class*="span"],.row-fluid .input-prepend [class*="span"],.row-fluid .input-append [class*="span"]{display:inline-block;}
            input,textarea,.uneditable-input{margin-left:0;}
            .controls-row [class*="span"]+[class*="span"]{margin-left:20px;}
            input.span12,textarea.span12,.uneditable-input.span12{width:926px;}
            input.span11,textarea.span11,.uneditable-input.span11{width:846px;}
            input.span10,textarea.span10,.uneditable-input.span10{width:766px;}
            input.span9,textarea.span9,.uneditable-input.span9{width:686px;}
            input.span8,textarea.span8,.uneditable-input.span8{width:606px;}
            input.span7,textarea.span7,.uneditable-input.span7{width:526px;}
            input.span6,textarea.span6,.uneditable-input.span6{width:446px;}
            input.span5,textarea.span5,.uneditable-input.span5{width:366px;}
            input.span4,textarea.span4,.uneditable-input.span4{width:286px;}
            input.span3,textarea.span3,.uneditable-input.span3{width:206px;}
            input.span2,textarea.span2,.uneditable-input.span2{width:126px;}
            input.span1,textarea.span1,.uneditable-input.span1{width:46px;}
            .controls-row{*zoom:1;}.controls-row:before,.controls-row:after{display:table;content:"";line-height:0;}
            .controls-row:after{clear:both;}
            .controls-row [class*="span"],.row-fluid .controls-row [class*="span"]{float:left;}
            .controls-row .checkbox[class*="span"],.controls-row .radio[class*="span"]{padding-top:5px;}
            input[disabled],select[disabled],textarea[disabled],input[readonly],select[readonly],textarea[readonly]{cursor:not-allowed;background-color:#eeeeee;}
            input[type="radio"][disabled],input[type="checkbox"][disabled],input[type="radio"][readonly],input[type="checkbox"][readonly]{background-color:transparent;}
            .control-group.warning .control-label,.control-group.warning .help-block,.control-group.warning .help-inline{color:#c09853;}
            .control-group.warning .checkbox,.control-group.warning .radio,.control-group.warning input,.control-group.warning select,.control-group.warning textarea{color:#c09853;}
            .control-group.warning input,.control-group.warning select,.control-group.warning textarea{border-color:#c09853;-webkit-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075);-moz-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075);box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075);}.control-group.warning input:focus,.control-group.warning select:focus,.control-group.warning textarea:focus{border-color:#a47e3c;-webkit-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075),0 0 6px #dbc59e;-moz-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075),0 0 6px #dbc59e;box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075),0 0 6px #dbc59e;}
            .control-group.warning .input-prepend .add-on,.control-group.warning .input-append .add-on{color:#c09853;background-color:#fcf8e3;border-color:#c09853;}
            .control-group.error .control-label,.control-group.error .help-block,.control-group.error .help-inline{color:#b94a48;}
            .control-group.error .checkbox,.control-group.error .radio,.control-group.error input,.control-group.error select,.control-group.error textarea{color:#b94a48;}
            .control-group.error input,.control-group.error select,.control-group.error textarea{border-color:#b94a48;-webkit-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075);-moz-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075);box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075);}.control-group.error input:focus,.control-group.error select:focus,.control-group.error textarea:focus{border-color:#953b39;-webkit-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075),0 0 6px #d59392;-moz-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075),0 0 6px #d59392;box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075),0 0 6px #d59392;}
            .control-group.error .input-prepend .add-on,.control-group.error .input-append .add-on{color:#b94a48;background-color:#f2dede;border-color:#b94a48;}
            .control-group.success .control-label,.control-group.success .help-block,.control-group.success .help-inline{color:#468847;}
            .control-group.success .checkbox,.control-group.success .radio,.control-group.success input,.control-group.success select,.control-group.success textarea{color:#468847;}
            .control-group.success input,.control-group.success select,.control-group.success textarea{border-color:#468847;-webkit-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075);-moz-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075);box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075);}.control-group.success input:focus,.control-group.success select:focus,.control-group.success textarea:focus{border-color:#356635;-webkit-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075),0 0 6px #7aba7b;-moz-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075),0 0 6px #7aba7b;box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075),0 0 6px #7aba7b;}
            .control-group.success .input-prepend .add-on,.control-group.success .input-append .add-on{color:#468847;background-color:#dff0d8;border-color:#468847;}
            .control-group.info .control-label,.control-group.info .help-block,.control-group.info .help-inline{color:#3a87ad;}
            .control-group.info .checkbox,.control-group.info .radio,.control-group.info input,.control-group.info select,.control-group.info textarea{color:#3a87ad;}
            .control-group.info input,.control-group.info select,.control-group.info textarea{border-color:#3a87ad;-webkit-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075);-moz-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075);box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075);}.control-group.info input:focus,.control-group.info select:focus,.control-group.info textarea:focus{border-color:#2d6987;-webkit-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075),0 0 6px #7ab5d3;-moz-box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075),0 0 6px #7ab5d3;box-shadow:inset 0 1px 1px rgba(0, 0, 0, 0.075),0 0 6px #7ab5d3;}
            .control-group.info .input-prepend .add-on,.control-group.info .input-append .add-on{color:#3a87ad;background-color:#d9edf7;border-color:#3a87ad;}
            input:focus:invalid,textarea:focus:invalid,select:focus:invalid{color:#b94a48;border-color:#ee5f5b;}input:focus:invalid:focus,textarea:focus:invalid:focus,select:focus:invalid:focus{border-color:#e9322d;-webkit-box-shadow:0 0 6px #f8b9b7;-moz-box-shadow:0 0 6px #f8b9b7;box-shadow:0 0 6px #f8b9b7;}
            .form-actions{padding:19px 20px 20px;margin-top:20px;margin-bottom:20px;background-color:#f5f5f5;border-top:1px solid #e5e5e5;*zoom:1;}.form-actions:before,.form-actions:after{display:table;content:"";line-height:0;}
            .form-actions:after{clear:both;}
            .help-block,.help-inline{color:#595959;}
            .help-block{display:block;margin-bottom:10px;}
            .help-inline{display:inline-block;*display:inline;*zoom:1;vertical-align:middle;padding-left:5px;}
            .input-append,.input-prepend{display:inline-block;margin-bottom:10px;vertical-align:middle;font-size:0;white-space:nowrap;}.input-append input,.input-prepend input,.input-append select,.input-prepend select,.input-append .uneditable-input,.input-prepend .uneditable-input,.input-append .dropdown-menu,.input-prepend .dropdown-menu,.input-append .popover,.input-prepend .popover{font-size:14px;}
            .input-append input,.input-prepend input,.input-append select,.input-prepend select,.input-append .uneditable-input,.input-prepend .uneditable-input{position:relative;margin-bottom:0;*margin-left:0;vertical-align:top;-webkit-border-radius:0 4px 4px 0;-moz-border-radius:0 4px 4px 0;border-radius:0 4px 4px 0;}.input-append input:focus,.input-prepend input:focus,.input-append select:focus,.input-prepend select:focus,.input-append .uneditable-input:focus,.input-prepend .uneditable-input:focus{z-index:2;}
            .input-append .add-on,.input-prepend .add-on{display:inline-block;width:auto;height:20px;min-width:16px;padding:4px 5px;font-size:14px;font-weight:normal;line-height:20px;text-align:center;text-shadow:0 1px 0 #ffffff;background-color:#eeeeee;border:1px solid #ccc;}
            .input-append .add-on,.input-prepend .add-on,.input-append .btn,.input-prepend .btn,.input-append .btn-group>.dropdown-toggle,.input-prepend .btn-group>.dropdown-toggle{vertical-align:top;-webkit-border-radius:0;-moz-border-radius:0;border-radius:0;}
            .input-append .active,.input-prepend .active{background-color:#a9dba9;border-color:#46a546;}
            .input-prepend .add-on,.input-prepend .btn{margin-right:-1px;}
            .input-prepend .add-on:first-child,.input-prepend .btn:first-child{-webkit-border-radius:4px 0 0 4px;-moz-border-radius:4px 0 0 4px;border-radius:4px 0 0 4px;}
            .input-append input,.input-append select,.input-append .uneditable-input{-webkit-border-radius:4px 0 0 4px;-moz-border-radius:4px 0 0 4px;border-radius:4px 0 0 4px;}.input-append input+.btn-group .btn:last-child,.input-append select+.btn-group .btn:last-child,.input-append .uneditable-input+.btn-group .btn:last-child{-webkit-border-radius:0 4px 4px 0;-moz-border-radius:0 4px 4px 0;border-radius:0 4px 4px 0;}
            .input-append .add-on,.input-append .btn,.input-append .btn-group{margin-left:-1px;}
            .input-append .add-on:last-child,.input-append .btn:last-child,.input-append .btn-group:last-child>.dropdown-toggle{-webkit-border-radius:0 4px 4px 0;-moz-border-radius:0 4px 4px 0;border-radius:0 4px 4px 0;}
            .input-prepend.input-append input,.input-prepend.input-append select,.input-prepend.input-append .uneditable-input{-webkit-border-radius:0;-moz-border-radius:0;border-radius:0;}.input-prepend.input-append input+.btn-group .btn,.input-prepend.input-append select+.btn-group .btn,.input-prepend.input-append .uneditable-input+.btn-group .btn{-webkit-border-radius:0 4px 4px 0;-moz-border-radius:0 4px 4px 0;border-radius:0 4px 4px 0;}
            .input-prepend.input-append .add-on:first-child,.input-prepend.input-append .btn:first-child{margin-right:-1px;-webkit-border-radius:4px 0 0 4px;-moz-border-radius:4px 0 0 4px;border-radius:4px 0 0 4px;}
            .input-prepend.input-append .add-on:last-child,.input-prepend.input-append .btn:last-child{margin-left:-1px;-webkit-border-radius:0 4px 4px 0;-moz-border-radius:0 4px 4px 0;border-radius:0 4px 4px 0;}
            .input-prepend.input-append .btn-group:first-child{margin-left:0;}
            input.search-query{padding-right:14px;padding-right:4px \9;padding-left:14px;padding-left:4px \9;margin-bottom:0;-webkit-border-radius:15px;-moz-border-radius:15px;border-radius:15px;}
            .form-search .input-append .search-query,.form-search .input-prepend .search-query{-webkit-border-radius:0;-moz-border-radius:0;border-radius:0;}
            .form-search .input-append .search-query{-webkit-border-radius:14px 0 0 14px;-moz-border-radius:14px 0 0 14px;border-radius:14px 0 0 14px;}
            .form-search .input-append .btn{-webkit-border-radius:0 14px 14px 0;-moz-border-radius:0 14px 14px 0;border-radius:0 14px 14px 0;}
            .form-search .input-prepend .search-query{-webkit-border-radius:0 14px 14px 0;-moz-border-radius:0 14px 14px 0;border-radius:0 14px 14px 0;}
            .form-search .input-prepend .btn{-webkit-border-radius:14px 0 0 14px;-moz-border-radius:14px 0 0 14px;border-radius:14px 0 0 14px;}
            .form-search input,.form-inline input,.form-horizontal input,.form-search textarea,.form-inline textarea,.form-horizontal textarea,.form-search select,.form-inline select,.form-horizontal select,.form-search .help-inline,.form-inline .help-inline,.form-horizontal .help-inline,.form-search .uneditable-input,.form-inline .uneditable-input,.form-horizontal .uneditable-input,.form-search .input-prepend,.form-inline .input-prepend,.form-horizontal .input-prepend,.form-search .input-append,.form-inline .input-append,.form-horizontal .input-append{display:inline-block;*display:inline;*zoom:1;margin-bottom:0;vertical-align:middle;}
            .form-search .hide,.form-inline .hide,.form-horizontal .hide{display:none;}
            .form-search label,.form-inline label,.form-search .btn-group,.form-inline .btn-group{display:inline-block;}
            .form-search .input-append,.form-inline .input-append,.form-search .input-prepend,.form-inline .input-prepend{margin-bottom:0;}
            .form-search .radio,.form-search .checkbox,.form-inline .radio,.form-inline .checkbox{padding-left:0;margin-bottom:0;vertical-align:middle;}
            .form-search .radio input[type="radio"],.form-search .checkbox input[type="checkbox"],.form-inline .radio input[type="radio"],.form-inline .checkbox input[type="checkbox"]{float:left;margin-right:3px;margin-left:0;}
            .control-group{margin-bottom:10px;}
            legend+.control-group{margin-top:20px;-webkit-margin-top-collapse:separate;}
            .form-horizontal .control-group{margin-bottom:20px;*zoom:1;}.form-horizontal .control-group:before,.form-horizontal .control-group:after{display:table;content:"";line-height:0;}
            .form-horizontal .control-group:after{clear:both;}
            .form-horizontal .control-label{float:left;width:160px;padding-top:5px;text-align:right;}
            .form-horizontal .controls{*display:inline-block;*padding-left:20px;margin-left:180px;*margin-left:0;}.form-horizontal .controls:first-child{*padding-left:180px;}
            .form-horizontal .help-block{margin-bottom:0;}
            .form-horizontal input+.help-block,.form-horizontal select+.help-block,.form-horizontal textarea+.help-block,.form-horizontal .uneditable-input+.help-block,.form-horizontal .input-prepend+.help-block,.form-horizontal .input-append+.help-block{margin-top:10px;}
            .form-horizontal .form-actions{padding-left:180px;}
            .btn{display:inline-block;*display:inline;*zoom:1;padding:4px 12px;margin-bottom:0;font-size:14px;line-height:20px;text-align:center;vertical-align:middle;cursor:pointer;color:#333333;text-shadow:0 1px 1px rgba(255, 255, 255, 0.75);background-color:#f5f5f5;background-image:-moz-linear-gradient(top, #ffffff, #e6e6e6);background-image:-webkit-gradient(linear, 0 0, 0 100%, from(#ffffff), to(#e6e6e6));background-image:-webkit-linear-gradient(top, #ffffff, #e6e6e6);background-image:-o-linear-gradient(top, #ffffff, #e6e6e6);background-image:linear-gradient(to bottom, #ffffff, #e6e6e6);background-repeat:repeat-x;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffffffff', endColorstr='#ffe6e6e6', GradientType=0);border-color:#e6e6e6 #e6e6e6 #bfbfbf;border-color:rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.25);*background-color:#e6e6e6;filter:progid:DXImageTransform.Microsoft.gradient(enabled = false);border:1px solid #cccccc;*border:0;border-bottom-color:#b3b3b3;-webkit-border-radius:4px;-moz-border-radius:4px;border-radius:4px;*margin-left:.3em;-webkit-box-shadow:inset 0 1px 0 rgba(255,255,255,.2), 0 1px 2px rgba(0,0,0,.05);-moz-box-shadow:inset 0 1px 0 rgba(255,255,255,.2), 0 1px 2px rgba(0,0,0,.05);box-shadow:inset 0 1px 0 rgba(255,255,255,.2), 0 1px 2px rgba(0,0,0,.05);}.btn:hover,.btn:focus,.btn:active,.btn.active,.btn.disabled,.btn[disabled]{color:#333333;background-color:#e6e6e6;*background-color:#d9d9d9;}
            .btn:active,.btn.active{background-color:#cccccc \9;}
            .btn:first-child{*margin-left:0;}
            .btn:hover,.btn:focus{color:#333333;text-decoration:none;background-position:0 -15px;-webkit-transition:background-position 0.1s linear;-moz-transition:background-position 0.1s linear;-o-transition:background-position 0.1s linear;transition:background-position 0.1s linear;}
            .btn:focus{outline:thin dotted #333;outline:5px auto -webkit-focus-ring-color;outline-offset:-2px;}
            .btn.active,.btn:active{background-image:none;outline:0;-webkit-box-shadow:inset 0 2px 4px rgba(0,0,0,.15), 0 1px 2px rgba(0,0,0,.05);-moz-box-shadow:inset 0 2px 4px rgba(0,0,0,.15), 0 1px 2px rgba(0,0,0,.05);box-shadow:inset 0 2px 4px rgba(0,0,0,.15), 0 1px 2px rgba(0,0,0,.05);}
            .btn.disabled,.btn[disabled]{cursor:default;background-image:none;opacity:0.65;filter:alpha(opacity=65);-webkit-box-shadow:none;-moz-box-shadow:none;box-shadow:none;}
            .btn-large{padding:11px 19px;font-size:17.5px;-webkit-border-radius:6px;-moz-border-radius:6px;border-radius:6px;}
            .btn-large [class^="icon-"],.btn-large [class*=" icon-"]{margin-top:4px;}
            .btn-small{padding:2px 10px;font-size:11.9px;-webkit-border-radius:3px;-moz-border-radius:3px;border-radius:3px;}
            .btn-small [class^="icon-"],.btn-small [class*=" icon-"]{margin-top:0;}
            .btn-mini [class^="icon-"],.btn-mini [class*=" icon-"]{margin-top:-1px;}
            .btn-mini{padding:0 6px;font-size:10.5px;-webkit-border-radius:3px;-moz-border-radius:3px;border-radius:3px;}
            .btn-block{display:block;width:100%;padding-left:0;padding-right:0;-webkit-box-sizing:border-box;-moz-box-sizing:border-box;box-sizing:border-box;}
            .btn-block+.btn-block{margin-top:5px;}
            input[type="submit"].btn-block,input[type="reset"].btn-block,input[type="button"].btn-block{width:100%;}
            .btn-primary.active,.btn-warning.active,.btn-danger.active,.btn-success.active,.btn-info.active,.btn-inverse.active{color:rgba(255, 255, 255, 0.75);}
            .btn-primary{color:#ffffff;text-shadow:0 -1px 0 rgba(0, 0, 0, 0.25);background-color:#006dcc;background-image:-moz-linear-gradient(top, #0088cc, #0044cc);background-image:-webkit-gradient(linear, 0 0, 0 100%, from(#0088cc), to(#0044cc));background-image:-webkit-linear-gradient(top, #0088cc, #0044cc);background-image:-o-linear-gradient(top, #0088cc, #0044cc);background-image:linear-gradient(to bottom, #0088cc, #0044cc);background-repeat:repeat-x;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr='#ff0088cc', endColorstr='#ff0044cc', GradientType=0);border-color:#0044cc #0044cc #002a80;border-color:rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.25);*background-color:#0044cc;filter:progid:DXImageTransform.Microsoft.gradient(enabled = false);}.btn-primary:hover,.btn-primary:focus,.btn-primary:active,.btn-primary.active,.btn-primary.disabled,.btn-primary[disabled]{color:#ffffff;background-color:#0044cc;*background-color:#003bb3;}
            .btn-primary:active,.btn-primary.active{background-color:#003399 \9;}
            .btn-warning{color:#ffffff;text-shadow:0 -1px 0 rgba(0, 0, 0, 0.25);background-color:#faa732;background-image:-moz-linear-gradient(top, #fbb450, #f89406);background-image:-webkit-gradient(linear, 0 0, 0 100%, from(#fbb450), to(#f89406));background-image:-webkit-linear-gradient(top, #fbb450, #f89406);background-image:-o-linear-gradient(top, #fbb450, #f89406);background-image:linear-gradient(to bottom, #fbb450, #f89406);background-repeat:repeat-x;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr='#fffbb450', endColorstr='#fff89406', GradientType=0);border-color:#f89406 #f89406 #ad6704;border-color:rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.25);*background-color:#f89406;filter:progid:DXImageTransform.Microsoft.gradient(enabled = false);}.btn-warning:hover,.btn-warning:focus,.btn-warning:active,.btn-warning.active,.btn-warning.disabled,.btn-warning[disabled]{color:#ffffff;background-color:#f89406;*background-color:#df8505;}
            .btn-warning:active,.btn-warning.active{background-color:#c67605 \9;}
            .btn-danger{color:#ffffff;text-shadow:0 -1px 0 rgba(0, 0, 0, 0.25);background-color:#da4f49;background-image:-moz-linear-gradient(top, #ee5f5b, #bd362f);background-image:-webkit-gradient(linear, 0 0, 0 100%, from(#ee5f5b), to(#bd362f));background-image:-webkit-linear-gradient(top, #ee5f5b, #bd362f);background-image:-o-linear-gradient(top, #ee5f5b, #bd362f);background-image:linear-gradient(to bottom, #ee5f5b, #bd362f);background-repeat:repeat-x;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffee5f5b', endColorstr='#ffbd362f', GradientType=0);border-color:#bd362f #bd362f #802420;border-color:rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.25);*background-color:#bd362f;filter:progid:DXImageTransform.Microsoft.gradient(enabled = false);}.btn-danger:hover,.btn-danger:focus,.btn-danger:active,.btn-danger.active,.btn-danger.disabled,.btn-danger[disabled]{color:#ffffff;background-color:#bd362f;*background-color:#a9302a;}
            .btn-danger:active,.btn-danger.active{background-color:#942a25 \9;}
            .btn-success{color:#ffffff;text-shadow:0 -1px 0 rgba(0, 0, 0, 0.25);background-color:#5bb75b;background-image:-moz-linear-gradient(top, #62c462, #51a351);background-image:-webkit-gradient(linear, 0 0, 0 100%, from(#62c462), to(#51a351));background-image:-webkit-linear-gradient(top, #62c462, #51a351);background-image:-o-linear-gradient(top, #62c462, #51a351);background-image:linear-gradient(to bottom, #62c462, #51a351);background-repeat:repeat-x;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr='#ff62c462', endColorstr='#ff51a351', GradientType=0);border-color:#51a351 #51a351 #387038;border-color:rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.25);*background-color:#51a351;filter:progid:DXImageTransform.Microsoft.gradient(enabled = false);}.btn-success:hover,.btn-success:focus,.btn-success:active,.btn-success.active,.btn-success.disabled,.btn-success[disabled]{color:#ffffff;background-color:#51a351;*background-color:#499249;}
            .btn-success:active,.btn-success.active{background-color:#408140 \9;}
            .btn-info{color:#ffffff;text-shadow:0 -1px 0 rgba(0, 0, 0, 0.25);background-color:#49afcd;background-image:-moz-linear-gradient(top, #5bc0de, #2f96b4);background-image:-webkit-gradient(linear, 0 0, 0 100%, from(#5bc0de), to(#2f96b4));background-image:-webkit-linear-gradient(top, #5bc0de, #2f96b4);background-image:-o-linear-gradient(top, #5bc0de, #2f96b4);background-image:linear-gradient(to bottom, #5bc0de, #2f96b4);background-repeat:repeat-x;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr='#ff5bc0de', endColorstr='#ff2f96b4', GradientType=0);border-color:#2f96b4 #2f96b4 #1f6377;border-color:rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.25);*background-color:#2f96b4;filter:progid:DXImageTransform.Microsoft.gradient(enabled = false);}.btn-info:hover,.btn-info:focus,.btn-info:active,.btn-info.active,.btn-info.disabled,.btn-info[disabled]{color:#ffffff;background-color:#2f96b4;*background-color:#2a85a0;}
            .btn-info:active,.btn-info.active{background-color:#24748c \9;}
            .btn-inverse{color:#ffffff;text-shadow:0 -1px 0 rgba(0, 0, 0, 0.25);background-color:#363636;background-image:-moz-linear-gradient(top, #444444, #222222);background-image:-webkit-gradient(linear, 0 0, 0 100%, from(#444444), to(#222222));background-image:-webkit-linear-gradient(top, #444444, #222222);background-image:-o-linear-gradient(top, #444444, #222222);background-image:linear-gradient(to bottom, #444444, #222222);background-repeat:repeat-x;filter:progid:DXImageTransform.Microsoft.gradient(startColorstr='#ff444444', endColorstr='#ff222222', GradientType=0);border-color:#222222 #222222 #000000;border-color:rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.1) rgba(0, 0, 0, 0.25);*background-color:#222222;filter:progid:DXImageTransform.Microsoft.gradient(enabled = false);}.btn-inverse:hover,.btn-inverse:focus,.btn-inverse:active,.btn-inverse.active,.btn-inverse.disabled,.btn-inverse[disabled]{color:#ffffff;background-color:#222222;*background-color:#151515;}
            .btn-inverse:active,.btn-inverse.active{background-color:#080808 \9;}
            button.btn,input[type="submit"].btn{*padding-top:3px;*padding-bottom:3px;}button.btn::-moz-focus-inner,input[type="submit"].btn::-moz-focus-inner{padding:0;border:0;}
            button.btn.btn-large,input[type="submit"].btn.btn-large{*padding-top:7px;*padding-bottom:7px;}
            button.btn.btn-small,input[type="submit"].btn.btn-small{*padding-top:3px;*padding-bottom:3px;}
            button.btn.btn-mini,input[type="submit"].btn.btn-mini{*padding-top:1px;*padding-bottom:1px;}
            .btn-link,.btn-link:active,.btn-link[disabled]{background-color:transparent;background-image:none;-webkit-box-shadow:none;-moz-box-shadow:none;box-shadow:none;}
            .btn-link{border-color:transparent;cursor:pointer;color:#0088cc;-webkit-border-radius:0;-moz-border-radius:0;border-radius:0;}
            .btn-link:hover,.btn-link:focus{color:#005580;text-decoration:underline;background-color:transparent;}
            .btn-link[disabled]:hover,.btn-link[disabled]:focus{color:#333333;text-decoration:none;}
            .alert{padding:8px 35px 8px 14px;margin-bottom:20px;text-shadow:0 1px 0 rgba(255, 255, 255, 0.5);background-color:#fcf8e3;border:1px solid #fbeed5;-webkit-border-radius:4px;-moz-border-radius:4px;border-radius:4px;}
            .alert,.alert h4{color:#c09853;}
            .alert h4{margin:0;}
            .alert .close{position:relative;top:-2px;right:-21px;line-height:20px;}
            .alert-success{background-color:#dff0d8;border-color:#d6e9c6;color:#468847;}
            .alert-success h4{color:#468847;}
            .alert-danger,.alert-error{background-color:#f2dede;border-color:#eed3d7;color:#b94a48;}
            .alert-danger h4,.alert-error h4{color:#b94a48;}
            .alert-info{background-color:#d9edf7;border-color:#bce8f1;color:#3a87ad;}
            .alert-info h4{color:#3a87ad;}
            .alert-block{padding-top:14px;padding-bottom:14px;}
            .alert-block>p,.alert-block>ul{margin-bottom:0;}
            .alert-block p+p{margin-top:5px;}
            .close{float:right;font-size:20px;font-weight:bold;line-height:20px;color:#000000;text-shadow:0 1px 0 #ffffff;opacity:0.2;filter:alpha(opacity=20);}.close:hover,.close:focus{color:#000000;text-decoration:none;cursor:pointer;opacity:0.4;filter:alpha(opacity=40);}
            button.close{padding:0;cursor:pointer;background:transparent;border:0;-webkit-appearance:none;}
            /*Metronic styles*/
            body {color: #000000;direction: ltr;font-family: 'Open Sans',sans-serif;font-size: 13px;margin: 0 !important;padding: 0 !important;}
            /*removeroundsfromallelements*/
            div,input,select,textarea,span,img,table,td,th,p,a,button,ul,li{-webkit-border-radius:0!important;-moz-border-radius:0!important;border-radius:0!important;}
            a:focus{outline:none!important;}
            a:hover,a:active{outline:0!important;}
            select:focus{outline:none!important;}
            .btn{    background-color:#e5e5e5;    background-image:none;    filter:none;    border:0;    padding:7px14px;        font-family:"SegoeUI",Helvetica,Arial,sans-serif;font-size:14px;    color:#333333;    cursor:pointer;    outline:none;-webkit-box-shadow:none!important;-moz-box-shadow:none!important;box-shadow:none!important;-webkit-border-radius:0!important;-moz-border-radius:0!important;border-radius:0!important;-webkit-text-shadow:none;-moz-text-shadow:none;text-shadow:none;}
            .btn:hover,.btn:focus,.btn:active,.btn.active,.btn[disabled],.btn.disabled{color:#333333;background-color:#d8d8d8!important;}
            .btn.red-stripe{    border-left:3pxsolid#d84a38;}
            .btn.blue-stripe{    border-left:3pxsolid#4d90fe;}
            .btn.purple-stripe{    border-left:3pxsolid#852b99;}
            .btn.green-stripe{    border-left:3pxsolid#35aa47;}
            .btn.yellow-stripe{border-left:3pxsolid#ffb848;}
            /*Red*/
            .btn.red{color:white;text-shadow:none;    background-color:#d84a38;}
            .btn.red:hover,.btn.red:focus,.btn.red:active,.btn.red.active,.btn.red[disabled],.btn.red.disabled{background-color:#bb2413!important;color:#fff!important;}
            .btn-group.btn.red.dropdown-toggle{background-color:#d84a38!important;}
            .btn-group.red.blue:hover,.btn-group.red.blue:focus,.btn-group.red.blue:active,.btn-group.red.blue.active,.btn-group.red.blue.disabled,.btn-group.red.blue[disabled]{background-color:#bb2413!important;color:#fff!important;}
            /*Blue*/
            .btn.transparent{color:black;text-shadow:none;background-color:transparent;}
            .btn.blue{color:white;text-shadow:none;    background-color:#4d90fe;}
            .btn.blue:hover,.btn.blue:focus,.btn.blue:active,.btn.blue.active,.btn.blue[disabled],.btn.blue.disabled{background-color:#0362fd!important;color:#fff!important;}
            .btn-group.btn.blue.dropdown-toggle{background-color:#4d90fe!important;}
            .btn-group.btn.blue:hover,.btn-group.btn.blue:focus,.btn-group.btn.blue:active,.btn-group.btn.blue.active,.btn-group.btn.blue.disabled,.btn-group.btn.blue[disabled]{background-color:#0362fd!important;color:#fff!important;}
            /*Green*/
            .btn.green{color:white;text-shadow:none;    background-color:#35aa47;}
            .btn.green:hover,.btn.green:focus,.btn.green:active,.btn.green.active,.btn.green.disabled,.btn.green[disabled]{background-color:#1d943b!important;color:#fff!important;}
            .btn-group.btn.green.dropdown-toggle{background-color:#35aa47!important;}
            .btn-group.btn.green:hover,.btn-group.btn.green:focus,.btn-group.btn.green:active,.btn-group.btn.green.active,.btn-group.btn.green.disabled,.btn-group.btn.green[disabled]{background-color:#1d943b!important;color:#fff!important;}
            /*Purple*/
            .btn.purple{color:white;text-shadow:none;    background-color:#852b99;}
            .btn.purple:hover,.btn.purple:focus,.btn.purple:active,.btn.purple.active,.btn.purple.disabled,.btn.purple[disabled]{background-color:#6d1b81!important;color:#fff!important;}
            .btn-group.btn.purple.dropdown-toggle{background-color:#852b99!important;}
            .btn-group.btn.purple:hover,.btn-group.btn.purple:focus,.btn-group.btn.purple:active,.btn-group.btn.purple.active,.btn-group.btn.purple.disabled,.btn-group.btn.purple[disabled]{background-color:#6d1b81!important;color:#fff!important;}
            /*Yellow*/
            .btn.yellow{color:white;text-shadow:none;    background-color:#ffb848;}
            .btn.yellow:hover,.btn.yellow:focus,.btn.yellow:active,.btn.yellow.active,.btn.yellow.disabled,.btn.yellow[disabled]{background-color:#eca22e!important;color:#fff!important;}
            .btn-group.btn.yellow.dropdown-toggle{background-color:#ffb848!important;}
            .btn-group.btn.yellow:hover,.btn-group.btn.yellow:focus,.btn-group.btn.yellow:active,.btn-group.btn.yellow.active,.btn-group.btn.yellow.disabled,.btn-group.btn.yellow[disabled]{background-color:#eca22e!important;color:#fff!important;}
            /*Black*/
            .btn.black{color:white;text-shadow:none;    background-color:#555555;}
            .btn.black:hover,.btn.black:focus,.btn.black:active,.btn.black.active,.btn.black.disabled,.btn.black[disabled]{background-color:#222222!important;color:#fff!important;}
            .btn-group.btn.black.dropdown-toggle{background-color:#555555!important;}
            .btn-group.btn.black:hover,.btn-group.btn.black:focus,.btn-group.btn.black:active,.btn-group.btn.black.active,.btn-group.btn.black.disabled,.btn-group.btn.black[disabled]{background-color:#222222!important;color:#fff!important;}
            .mini{height:13px;font-size:11px!important;line-height:13px;padding:4px10px;}
            .big{height:38px;    font-size:18px;    line-height:38px;        padding:8px16px;}
            button.btn.big,input[type="button"].btn.big,input[type="submit"].btn.big{height:54px;padding-top:9px;padding-bottom:8px;}
            button.btn.mini,input[type="button"].btn.mini,input[type="submit"].btn.mini{height:21px;padding-top:3px;padding-bottom:3px;}
            a.btn.big.btn-block{height:54px;}
            /***Forms***/
            label.m-wrap,input.m-wrap,button.m-wrap,select.m-wrap,textarea.m-wrap{font-size:14px;font-weight:normal;line-height:20px;}
            input.m-wrap,button.m-wrap,select.m-wrap,textarea.m-wrap{font-family:"SegoeUI","HelveticaNeue",Helvetica,Arial,sans-serif;}
            label.m-wrap{display:block;margin-bottom:5px;}
            .uneditable-input,textarea.m-wrap,input[type="text"].m-wrap,input[type="password"].m-wrap,input[type="datetime"].m-wrap,input[type="datetime-local"].m-wrap,input[type="date"].m-wrap,input[type="month"].m-wrap,input[type="time"].m-wrap,input[type="week"].m-wrap,input[type="number"].m-wrap,input[type="email"].m-wrap,input[type="url"].m-wrap,input[type="search"].m-wrap,input[type="tel"].m-wrap,input[type="color"].m-wrap{-webkit-appearance:none!important;    color:#333333;        outline:0;height:20px;    padding:6px6px!important;line-height:20px;font-size:14px;font-weight:normal;vertical-align:top;    background-color:#ffffff;    background-image:none!important;filter:none!important;    -webkit-box-shadow:none!important;    -moz-box-shadow:none!important;    box-shadow:none!important;    -webkit-border-radius:0px;    -moz-border-radius:0px;    border-radius:0px;background:transparent;}
            input.m-wrap{border:1pxsolid#e5e5e5;}
            textarea.m-wrap{height:auto;}
            .uneditable-input.focus,textarea.m-wrap:focus,select.m-wrap:focus,input[type="text"].m-wrap:focus,input[type="password"].m-wrap:focus,input[type="datetime"].m-wrap:focus,input[type="datetime-local"].m-wrap:focus,input[type="date"].m-wrap:focus,input[type="month"].m-wrap:focus,input[type="time"].m-wrap:focus,input[type="week"].m-wrap:focus,input[type="number"].m-wrap:focus,input[type="email"].m-wrap:focus,input[type="url"].m-wrap:focus,input[type="search"].m-wrap:focus,input[type="tel"].m-wrap:focus,input[type="color"].m-wrap:focus,.m-uneditable-input:focus{border-color:#999999;outline:0!important;/*IE6-9*/
                                                                                                                                                                                                        -webkit-box-shadow:none;-moz-box-shadow:none;box-shadow:none;}
            input[disabled],select[disabled],textarea[disabled]{cursor:not-allowed;background-color:#F4F4F4!important;}
            input[readonly],select[readonly],textarea[readonly]{cursor:not-allowed;background-color:#F9F9F9!important;}
            input[type="radio"][disabled],input[type="checkbox"][disabled],input[type="radio"][readonly],input[type="checkbox"][readonly]{background-color:transparent;}
            input[type="radio"].m-wrap,input[type="checkbox"].m-wrap{    margin:4px00;    margin-top:1px\9;    *margin-top:0;    line-height:normal;    cursor:pointer;            -webkit-box-sizing:border-box;    -moz-box-sizing:border-box;    box-sizing:border-box;        }
            select.m-wrap,input[type="file"].m-wrap{height:34px!important;/*InIE7,theheightoftheselectelementcannotbechangedbyheight,onlyfont-size*/
                                                    *margin-top:4px;/*ForIE7,addtopmargintoalignselectwithlabels*/
                                                    line-height:30px;}
            select.m-wrap{width:220px;background-color:#ffffff;background-image:none!important;filter:none!important;border:1pxsolid#e5e5e5;outline:none;}
            select[multiple].m-wrap,select[size].m-wrap{height:auto!important;}
            select.m-wrap:focus,input[type="file"].m-wrap:focus,input[type="radio"].m-wrap:focus,input[type="checkbox"].m-wrap:focus{outline:thindotted#333333;outline:5pxauto-webkit-focus-ring-color;outline-offset:-2px;-webkit-box-shadow:none!important;-moz-box-shadow:none!important;box-shadow:none!important;}
            input[class*="span"].m-wrap{float:none;height:34px!important;margin-left:0;}
            select[class*="span"].m-wrap,textarea[class*="span"].m-wrap{float:none;margin-left:0;}
            /*fixbuttontoolbars*/
            .btn-toolbar>.btn-group>.btn:hover,.btn-toolbar>.btn-group>.btn:focus,.btn-toolbar>.btn-group>.btn:active,.btn-toolbar>.btn-group>.btn.active{z-index:0!important;}
            .input-prepend,.input-append{    border:0;display:inline-block;}
            .input-append.add-on,.input-prepend.add-on{display:inline-block;width:auto;height:24px;min-width:16px;padding:4px5px;font-size:14px;font-weight:normal;line-height:24px;text-align:center;text-shadow:01px0#ffffff;background-color:#e5e5e5;border:1pxsolid#e5e5e5;}
            .input-append.add-on>.halflings-icon,.input-prepend.add-on>i,.input-prepend.add-on>[class^="icon-"]{    margin-top:5px;    margin-left:3px;}
            .input-append.add-on>.halflings-icon.input-append.add-on>i,.input-append.add-on>[class^="icon-"]{    margin-top:5px;    margin-left:0px;}
            .input-append.m-wrap,.input-append.m-wrap:focus{    border-right:0!important;margin-right:1px;}
            .input-prependinput,.input-prependinput:focus{    border-left:0!important;margin-left:1px;}
            .input-appendinput[class*="span"],.input-prependinput[class*="span"]{display:inline-block!important;}
            .m-wrap.xsmall{width:50px!important;}
            .m-wrap.small{width:120px!important;}
            .m-wrap.medium{width:206px!important;}
            .m-wrap.large{width:320px!important;}
            .m-wrap.huge{width:480px!important;font-size:24px!important;height:36px!important;line-height:36px!important;padding:22px8px!important;}
            select.m-wrap.xsmall{width:64px!important;}
            select.m-wrap.small{width:134px!important;}
            select.m-wrap.medium{width:220px!important;}
            select.m-wrap.large{width:334px!important;}
        </style>
    </head>

<body>
<div class="container" id="page">
    <div id="content">
        <form class="form-horizontal" method="POST" id="settings-form">
                <!-- БД для импорта -->
                <div class="row">
                    <div class="span6">
                        <fieldset>
                            <legend>Доступы к БД - старая версия</legend>
                            <div class="control-group">
                                <label class="control-label" for="dbImportHost">Сервер</label>
                                <div class="controls">
                                    <input type="text" id="dbImportHost" name="dbImportHost" value="<?php echo isset($_POST['dbImportHost']) ? $_POST['dbImportHost'] : 'localhost'; ?>">
                                </div>
                            </div>
                            <div class="control-group">
                                <label class="control-label" for="dbImportName">Название БД</label>
                                <div class="controls">
                                    <input type="text" id="dbImportName" name="dbImportName" value="<?php echo $_POST['dbImportName']; ?>">
                                </div>
                            </div>
                            <div class="control-group">
                                <label class="control-label" for="dbImportUsername">Пользователь</label>
                                <div class="controls">
                                    <input type="text" id="dbImportUsername" name="dbImportUsername" value="<?php echo $_POST['dbImportUsername']; ?>">
                                </div>
                            </div>
                            <div class="control-group">
                                <label class="control-label" for="dbImportPassword">Пароль</label>
                                <div class="controls">
                                    <input type="password" id="dbImportPassword" name="dbImportPassword" value="<?php echo $_POST['dbImportPassword']; ?>">
                                </div>
                            </div>
                            <div class="control-group">
                                <label class="control-label" for="dbImportTablePrefix">Префикс таблиц</label>
                                <div class="controls">
                                    <input type="text" id="dbImportTablePrefix" name="dbImportTablePrefix" value="<?php echo $_POST['dbImportTablePrefix']; ?>">
                                </div>
                            </div>
                        </fieldset>
                        <div class="control-group">
                            <div class="controls">
                                <input type="hidden" name="dbRewrite" id="dbRewrite" value="0"/>
                                <button type="submit" name="importControl" id="importExport" class="btn blue" <?=ImportControlModel::isControlAlredyImport()?'disabled':'';?> >Импорт данных модуля Контроль</button><br/><br/>
                                <button type="submit" name="importPosition" id="importExport" class="btn blue" <?=ImportPositionModel::isPositionAlredyImport()?'disabled':'';?> >Импорт данных модуля Позиции</button>&nbsp;&nbsp;
                            </div>
                        </div>
                    </div>

                    <!-- БД для экспорта -->
                    <div class="span6">
                        <fieldset>
                            <legend>Доступы к БД - новая версия</legend>
                            <div class="control-group">
                                <label class="control-label" for="dbExportHost">Сервер</label>
                                <div class="controls">
                                    <input type="text" id="dbExportHost" name="dbExportHost" value="<?php echo isset($_POST['dbExportHost']) ? $_POST['dbExportHost'] : 'localhost'; ?>">
                                </div>
                            </div>
                            <div class="control-group">
                                <label class="control-label" for="dbExportName">Название БД</label>
                                <div class="controls">
                                    <input type="text" id="dbExportName" name="dbExportName" value="<?php echo $_POST['dbExportName']; ?>">
                                </div>
                            </div>
                            <div class="control-group">
                                <label class="control-label" for="dbExportUsername">Пользователь</label>
                                <div class="controls">
                                    <input type="text" id="dbExportUsername" name="dbExportUsername" value="<?php echo $_POST['dbExportUsername']; ?>">
                                </div>
                            </div>
                            <div class="control-group">
                                <label class="control-label" for="dbExportPassword">Пароль</label>
                                <div class="controls">
                                    <input type="password" id="dbExportPassword" name="dbExportPassword" value="<?php echo $_POST['dbExportPassword']; ?>">
                                </div>
                            </div>
                            <div class="control-group">
                                <label class="control-label" for="dbExportTablePrefix">Префикс таблиц</label>
                                <div class="controls">
                                    <input type="text" id="dbExportTablePrefix" name="dbExportTablePrefix" value="<?php echo $_POST['dbExportTablePrefix']; ?>">
                                </div>
                            </div>
                        </fieldset>
                        <div class="control-group">
                            <div class="controls">
                                <button type="submit" name="clearExport" id="clearExport" class="btn blue">Очистить</button>
                            </div>
                        </div>
                    </div>
                </div>
        </form>

        <div class="clear">
        </div>

        <div id="footer">
            <!-- Сообщения -->
            <?php
                // Если были ошибки во время импорта
                if ( !is_null($errorMSG))
                {
                    echo "<div class = 'alert alert-error'>" .$errorMSG ."</div>";                    
                }
                else
                {
                    $msgObjects = array('importModel','controlModel','controlController','positionModel','positionController');
                    foreach ($msgObjects as $objName)
                    {
                        if (isset($$objName))
                        {
                            foreach ($$objName->getMessages() as $message)
                                echo "<div class = 'alert alert-".$message['type']."'>".$message['text'] ."</div>";
                        }
                    }
                }
            ?>
        </div><!-- footer -->
    </div><!-- content-->

</body>
</html>



<?php

/**********************************************************/
/**********************************************************/
/**********************************************************/
/**********************************************************/
/**********************************************************/

class ImportModel
{
    CONST IMPORT_DB_ID = 1;
    CONST EXPORT_DB_ID = 2;

    const DEFAULT_USER_ID = 1;
    const SC_SUPPORT_EMAIL = "support2@site-control.ru";

    protected static $errorMSG = null;    // Сообщение об ошибке во время импорта и нужные действия
    protected static $connectionErrors = false;

    protected static $importDb;
    protected static $exportDb;

    protected static $dbImportTablePrefix;
    protected static $dbExportTablePrefix;

    protected $messages = array();

    public $isErrors = false;


    // public function isSitesInExportDb()
    // {
    //     $sql = "SELECT COUNT(*) FROM " .self::getExportFullTablename('sites');
    // }


    /**
     * Конструктор
     */
    public function __construct($dbImport, $dbExport)
    {
        $this->connect2ImportDb($dbImport);
        $this->connect2ExportDb($dbExport);

        if ( !self::$connectionErrors)
        {
            self::$dbImportTablePrefix = isset($dbImport["dbImportTablePrefix"]) ? $dbImport["dbImportTablePrefix"] : '';
            self::$dbExportTablePrefix = isset($dbExport["dbExportTablePrefix"]) ? $dbExport["dbExportTablePrefix"] : '';
            // Проверим существование необходимых таблиц
            $needTables = $this->getAllBaseImportTablesWitoutPref();
            $this->checkExistsTables($needTables, self::IMPORT_DB_ID);
            $needTables = $this->getAllBaseExportTablesWitoutPref();
            $this->checkExistsTables($needTables, self::EXPORT_DB_ID);
        }
    }

    protected function fkCheckDisable()
    {
        $sql = "SET FOREIGN_KEY_CHECKS=0;";
        self::$exportDb->exec($sql);
    }

    protected function fkCheckEnable()
    {
        $sql = "SET FOREIGN_KEY_CHECKS=1;";
        self::$exportDb->exec($sql);
    }

    protected static function getImportFullTablename($name)
    {
        return "`" .self::$dbImportTablePrefix .$name ."`";
    }

    protected static function getExportFullTablename($name)
    {
        return "`" .self::$dbExportTablePrefix .$name ."`";
    }


    /**
     * Формируем строку для вставки одной командой
     * @param array tableName
     * @param array columns
     * @param array values
     * @return array string
     */
    protected function getMultiInsertCommand($tableName, $columns, $values)
    {
        if (is_array($columns) && count($values))
        {
            $result = "";
            // В одном запросе не более 300 строк
            $chunks = array_chunk($values, 300);
            foreach ($chunks as $key=>$chunk)
            {
                $values = $chunk;
                $result = $result ." INSERT INTO " .self::getExportFullTablename($tableName) ." (";
                // $result = "INSERT IGNORE INTO " .self::getExportFullTablename($tableName) ." (";
                $columnsNumElements = count($columns);
                $i=0;
                foreach ($columns as $columnName=>$columnType)
                {
                    $i++;
                    $result .= "`$columnName`";
                    // $result .= ($columnType=='s') ? "`$columnName`" : $columnName;
                    $result .= $i==$columnsNumElements ? ') ' : ',';   
                }
                // Результаты
                $result .= " VALUES";
                foreach ($values as $row)
                {
                    $result .= " (";
                    $i=0;
                    foreach ($columns as $columnName=>$columnType)
                    {
                        $i++;
                        // $value = ($columnType=='s') ? "'$row[$columnName]'" : $row[$columnName];
                        $value = ($columnType=='s') ? self::$exportDb->quote($row[$columnName]) : $row[$columnName];
                        if ($value=="''")
                            $value = 'NULL';
                        $result .= $value;
                        $result .= $i==$columnsNumElements ? ')' : ',';   
                    }
                    $result .= (bool)next($values) ? ', ' : ';';
                }
            }
            return $result;
        }
        else
            return false;
    }


    /**
     * Формируем лог
     */
    protected function printErrorsInLogFile($sql, PDOException $pdoExc, $isImportTable)
    {
        $logFileName = "import_sc_errors_" .date('d_m_Y') .".txt";
        self::$errorMSG = "ВНИМАНИЕ! При импорте данных произошла ошибка! Пожалуйста, сделайте следующие шаги: <br/>
                            1. {file_msg_template}<br/>
                            2. Очистите БД для новой версии (нажмите Очистить).<br/>
        ";

        if ($isImportTable)
            $db = self::$importDb;
        else
            $db = self::$exportDb;
        $writeInLog = "\n---------------------------------\n";
        $writeInLog = $writeInLog .date('H:i:s') .":\n";
        $writeInLog = $writeInLog ."SQL:\n$sql\n\n";
        // Пишем текст PDOException
        $writeInLog = $writeInLog ."PDOException: " .$pdoExc->getMessage() ."\n";
        // Если смогли записать в лог
        if (file_put_contents($logFileName, $writeInLog, FILE_APPEND)!==false)
            $fileMsg = "В той же директории, где лежит этот скрипт, должен был появиться файл с именем
                        $logFileName. Вы можете отправить его нам на адрес " .self::SC_SUPPORT_EMAIL
                        ." и мы постараемся Вам помочь.";
        else
            $fileMsg = "К сожалению, скрипт не смог сформировать лог, чтобы мы могли выяснить в чем дело. Проверьте права на запись в текущую директорию.";
        // Пишем ошибку в свойство
        self::$errorMSG = str_replace('{file_msg_template}', $fileMsg, self::$errorMSG);
    }


    /**
     * Выполняем команду на вставку
     */
    protected function runMultiInsertCommand($sql)
    {
        if ($sql===false)
            return false;

        // Разбиваем, если запрос большой на более мелкие и выполняем в цикле
        $arrSQL = explode(');', $sql);
        // Удаляем пустую строку в конце
        array_pop($arrSQL);

        foreach ($arrSQL as $sql)
        {
            $sql = $sql .');';
            try
            {
                // TODO транзакции?
                $this->fkCheckDisable();
                self::$exportDb->exec($sql);
                $this->fkCheckEnable();
            }
            catch(PDOException $exc)
            {
                // $msgText = "Произошла ошибка при попытке записи в БД для новой версии! ";
                // $msgText .= $exc->getMessage();
                // $this->messages[] = array('type' => 'error', 'text' => $msgText);
                $this->isErrors = true;
                $this->printErrorsInLogFile($sql, $exc, false);
            }            
        }
    }


    /**
     * Импорт регионов Яндекс
     */
    public function importYandexRegionsFromExportDB()
    {
        $sql = "SELECT * FROM " .self::getExportFullTablename('position_yandex_regions');
        try
        {
            return self::$exportDb->query($sql);
        }
        catch(PDOException $exc)
        {
            // $msgText = "Произошла ошибка при попытке чтения из БД для старой версии! ";
            // $msgText .= $exc->getMessage();
            // $this->messages[] = array('type' => 'error', 'text' => $msgText);
            $excText = $exc->getMessage();
            $this->isErrors = true;
            $this->printErrorsInLogFile($sql, $exc, true);
        }        
    }


    /**
     * Импорт
     */
    public function importSome($oldTableName)
    {
        $sql = "SELECT * FROM " .self::getImportFullTablename($oldTableName);
        try
        {
            return self::$importDb->query($sql);
        }
        catch(PDOException $exc)
        {
            // $msgText = "Произошла ошибка при попытке чтения из БД для старой версии! ";
            // $msgText .= $exc->getMessage();
            // $this->messages[] = array('type' => 'error', 'text' => $msgText);
            $excText = $exc->getMessage();
            $this->isErrors = true;
            $this->printErrorsInLogFile($sql, $exc, true);
        }        
    }


    /**
     * Импорт с Offset
     * chunkNum - имя куска
     */
    public function importSomeWithOffset($oldTableName, $chunkNum)
    {
        $limit = 1000;
        $offset = $chunkNum * $limit;
        $sql = "SELECT * FROM " .self::getImportFullTablename($oldTableName) . " LIMIT $limit OFFSET $offset";
        try
        {
            return self::$importDb->query($sql);
        }
        catch(PDOException $exc)
        {
            $excText = $exc->getMessage();
            $this->isErrors = true;
            $this->printErrorsInLogFile($sql, $exc, true);
        }        
    }


    /**
     * Экспорт в таблицу groups
     */
    public function exportGroups($oldGroups)
    {
        $values = array();
        foreach ($oldGroups as $group)
        {
            if ( !is_array($group))
                continue;
            $values = array_merge($values,array(array('id'=>$group["id"], 'name'=>$group["group"],'user_id'=>self::DEFAULT_USER_ID)));
        }
        $sql = $this->getMultiInsertCommand('groups', array('id'=>'i','name'=>'s','user_id'=>'i'), $values);
        $this->runMultiInsertCommand($sql);
    }


    /**
     * Экспорт в таблицу sites и sites_groups
     */
    public function exportSites($oldSites)
    {
        $sites = array();
        $sites_groups = array();
        foreach ($oldSites as $site)
        {
            if ( !is_array($site))
                continue;
            $sites = array_merge($sites,array(array('id'=>$site["id"], 'url'=>$site["url"],'user_id'=>self::DEFAULT_USER_ID)));

            if ( !is_null($site["id"]) && !is_null($site["group"]) )
                $sites_groups = array_merge($sites_groups,array(array('site_id'=>$site["id"], 'group_id'=>$site["group"])));
        }
        // Сайты
        $sql = $this->getMultiInsertCommand('sites', array('id'=>'i','url'=>'s','user_id'=>'i'), $sites);
        $this->runMultiInsertCommand($sql);
        // Связи с группами
        $sql = $this->getMultiInsertCommand('sites_groups', array('site_id'=>'i', 'group_id'=>'i'), $sites_groups);
        $this->runMultiInsertCommand($sql);
    }


    private function getAllBaseImportTablesWitoutPref()
    {
        return array(
                    'group',
                    'site',
                    'users',
                    'user_group',
                    'user_module',
        );
    }


    private function getAllBaseExportTablesWitoutPref()
    {
        return array(
                'groups',
                'sites',
                'sites_groups',
                'sites_users_modules_roles',
        );
    }


    /**
     * Чистим все таблицы для экспорта
     */
    public function truncateExportTables()
    {
        if ( !self::$connectionErrors)
        {
            $tables = $this->getAllBaseExportTablesWitoutPref();
            $tables = array_merge($tables, ImportControlModel::getAllControlExportTablesWitoutPref());
            $tables = array_merge($tables, ImportPositionModel::getAllPositionExportTablesWitoutPref());

            $sql = "";
            foreach ($tables as $table)
            {
                $sql .= "TRUNCATE ".self::getExportFullTablename($table) .";";
            }

            $this->fkCheckDisable();
            self::$exportDb->exec($sql);
            $this->messages[] = array('type' => 'success', 'text' => 'БД для новой версии очищена.');
            $this->fkCheckEnable();
            // Очищаем записи в сессиях
            unset($_SESSION['common_alredy_import']);
            unset($_SESSION['control_alredy_import']);
            unset($_SESSION['position_alredy_import']);
        }        
    }


    /**
     * Подключение
     */
    protected function connect2ImportDb($config)   
    {
/////
/////
        try
        {
            self::$importDb = new PDO('mysql:host='.$config["dbImportHost"].';dbname='.$config["dbImportName"], $config["dbImportUsername"], $config["dbImportPassword"]);
            self::$importDb->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
            self::$importDb->exec('SET NAMES UTF8');
        }
        catch(PDOException $exc)
        {
            $msgText = "Ошибка подключения к БД для старой версии! ";
            $msgText .= $exc->getMessage();
            $this->messages[] = array('type' => 'error', 'text' => $msgText);
            self::$connectionErrors = true;
        }
    }

    /**
     * Подключение
     */
    protected function connect2ExportDb($config)   
    {
/////
        // $config = array(
        //             'dbExportHost' => 'localhost',
        //             'dbExportName' => 'test_export',
        //             'dbExportUsername' => 'root',
        //             'dbExportPassword' => '',
        //             'dbExportTablePrefix' => '',
        // );
/////
        try
        {
            self::$exportDb = new PDO('mysql:host='.$config["dbExportHost"].';dbname='.$config["dbExportName"], $config["dbExportUsername"], $config["dbExportPassword"]);
            self::$exportDb->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
            self::$exportDb->exec('SET NAMES UTF8');
        }
        catch(PDOException $exc)
        {
            $msgText = "Ошибка подключения к БД для новой версии! ";
            $msgText .= $exc->getMessage();
            $this->messages[] = array('type' => 'error', 'text' => $msgText);
            self::$connectionErrors = true;
        }
    }


    /**
     * @param string tableName
     * @param bool dbId
     * @param bool fatalError
     */
    protected function checkExistsOneTable($tableName, $dbId, $fatalError=true)
    {
        if (self::$connectionErrors)
            return false;

        if ($dbId===self::IMPORT_DB_ID)
        {
            $db = self::$importDb;
            $tableName = self::$dbImportTablePrefix .$tableName;
            $msgVersion = "старой";
        }
        elseif ($dbId===self::EXPORT_DB_ID)
        {
            $db = self::$exportDb;
            $tableName = self::$dbExportTablePrefix .$tableName;
            $msgVersion = "новой";
        }

        $sql = "SHOW TABLES LIKE '" .$tableName ."'";
        $result = $db->query($sql);
        if ($result->fetch()===false)
        {
            if ($fatalError)
            {
                self::$connectionErrors = true;
                $this->messages[] = array('type' => 'error', 'text' => "Не удалось найти нужные таблицы в БД для $msgVersion версии! ($tableName)");
            }
            return false;
        }
        else
            return true;
    }


    /**
     * @param array tables
     * @param bool isImportDb
     */
    public function checkExistsTables($tables, $dbId, $fatalError=true)
    {
        if (empty($tables))
            return false;
        foreach ($tables as $tableName)
        {
            if ($this->checkExistsOneTable($tableName, $dbId, $fatalError)===false)
                return false;
        }
        return true;
    }


    public function getMessages()
    {
        return $this->messages;
    }

    public function isConnectionErrors()
    {
        return self::$connectionErrors;
    }

    public static function getErrorMSG()
    {
        return self::$errorMSG;
    }

    /**
     * Открываем сайты админу
     */
    public function setSumrForAdmin($moduleAlias)
    {
        // Получаем id модуля в таблице $modules
        $sql = "SELECT id FROM " .self::getExportFullTablename('modules') ." WHERE alias = '$moduleAlias'";
        $result = self::$exportDb->query($sql)->fetch();
        $moduleId = $result['id'];

        // Получаем все id сайтов
        $sql = "SELECT id FROM " .self::getExportFullTablename('sites');
        $result = self::$exportDb->query($sql);
        $values = array();
        foreach ($result as $key=>$row)
        {
            $values = array_merge($values,array(array('site_id'=>$row['id'], 'user_id'=>self::DEFAULT_USER_ID, 'module_id'=>$moduleId, 'role_id'=>3)));
        }
        $sql = $this->getMultiInsertCommand('sites_users_modules_roles', array('site_id'=>'i', 'user_id'=>'i', 'module_id'=>'i', 'role_id'=>'i'), $values);
        $this->runMultiInsertCommand($sql);
    }

    /**
     * Проверяет, нужно ли писать общие данные в новую БД
     * @return bool 
     */
    public function needWriteToCommonTablesExportDb()
    {
        if ( isset($_SESSION['common_alredy_import']) && $_SESSION['common_alredy_import']===true ) 
        {
            return false;
        }
        else
            return true;
    }


    public function isModuleInstallInExportDb($moduleAlias)
    {
        $sql = "SELECT id FROM " .self::getExportFullTablename('modules') ." WHERE alias = '$moduleAlias'";
        $result = (bool)self::$exportDb->query($sql)->fetch();
        if ($result===false)
        {
            $this->messages[] = array('type' => 'error', 'text' => "Этот модуль у Вас не установлен!");
            return false;
        }
        else
            return true;
    }

}




/**********************************************************/
/**********************************************************/
/**********************************************************/
/**********************************************************/
/**********************************************************/



class ImportControlModel extends ImportModel
{
    private $issetFreeTables = false;
    private $isControlPaid = false;
    public $doImportYandexBlogs = false;
    public $doImportWebArchive = false;


    public function __construct($dbImport, $dbExport)
    {
        parent::__construct($dbImport, $dbExport);
        $needTables = self::getAllControlFreeImportTablesWitoutPref();
        $this->issetFreeTables = $this->checkExistsTables($needTables, self::IMPORT_DB_ID, false);
        // Импортировать ли Яндекс блоги и webarchive
        $this->doImportWebArchive = $this->checkExistsTables(array('control_f1'), self::IMPORT_DB_ID, false);
        // $this->doImportYandexBlogs = $this->checkExistsTables(array('control_f2','control_f3','control_f4'), self::IMPORT_DB_ID, false);
        //
        $needTables = self::getAllControlExportTablesWitoutPref();
        $this->checkExistsTables($needTables, self::EXPORT_DB_ID);
        if ( !self::$connectionErrors)
            $this->checkOldVersion();
    }


    public static function isControlAlredyImport()
    {
        if ( isset($_SESSION['control_alredy_import']) && $_SESSION['control_alredy_import']===true ) 
            return true;
        else
            return false;
    }

    /**
     * Экспорт динамичеких показателей
     */
    public function exportDynamic($oldSome, $newTableName)
    {
        $values = array();
        foreach ($oldSome as $row)
        {
            if ( !is_array($row))
                continue;
            // Для правки странной структуры старой БД
            if ($row["value"]=='false')
                $row["value"] = 0;
            elseif ($row["value"]=='true')
                $row["value"] = 1;

            $values = array_merge($values,array(array('site_id'=>$row["siteid"], 'value'=>$row["value"], 'date'=>$row["date"])));
        }

        if ( !empty($values))
        {
            $sql = $this->getMultiInsertCommand($newTableName, array('site_id'=>'i','value'=>'s','date'=>'s'), $values);
            $this->runMultiInsertCommand($sql);
        }
    }
    

    /**
     * Экспорт Yandex Blogs и WHOIS
     */
    public function exportWHOIS($values)
    {
        if ( !empty($values))
        {
            $sql = $this->getMultiInsertCommand('control_whois', array('site_id'=>'i','control_dns'=>'s','control_created_date'=>'s','control_expired_date'=>'s'), $values);
            $this->runMultiInsertCommand($sql);
        }
    }

    /**
     * Экспорт Yandex Blogs и WHOIS
     */
    public function exportYandexBlogs($values)
    {
        if ( !empty($values))
        {
            $sql = $this->getMultiInsertCommand('control_yandex_blogs', array(
                                                                            'site_id'=>'i',
                                                                            'control_yandex_blogs_auth'=>'i',
                                                                            'control_yandex_blogs_pos'=>'i',
                                                                            'control_yandex_blogs_read'=>'i',
                                                                            'date'=>'s',
                                                                        ),
                                                                        $values
                                              );
            $this->runMultiInsertCommand($sql);
        }
    }

    /**
     * Метод устанавливает какую версию модуля
     * мы импортируем: платную или бесплатную
     */
    private function checkOldVersion()
    {
        // Проверим существование платных таблиц
        $paidTables = $this->getSomeControlPaidImportTablesWitoutPref();
        $this->isControlPaid = $this->checkExistsTables($paidTables, self::IMPORT_DB_ID, false);
    }


    /**
     * Импортировать ли бесплатные таблицы
     */
    public function doFreeImport()
    {
        return $this->issetFreeTables;
    }

    /**
     * Импортировать ли платные таблицы
     */
    public function doPaidTablesImport()
    {
        return $this->isControlPaid;
    }


    private function getSomeControlPaidImportTablesWitoutPref()
    {
        return array(
                    'dmoz',
                    'expire',
                    'gp',
                    'pr',
                    'tic',
                    'top100',
                    'yca',
                    'yp',
        );
    }

    
    private function getAllControlFreeImportTablesWitoutPref()
    {
        return array(
                    'freeconf',
                    'freedmoz',
                    'freeexpire',
                    'freegp',
                    'freepr',
                    'freerp',
                    'freetic',
                    'freetop100',
                    'freeupdate',
                    'freeyca',
                    'freeyp',
        );
    }


    public static function getAllControlExportTablesWitoutPref()
    {
        return array(
                'control_bing',
                'control_google',
                'control_yandex',
                'control_pr',
                'control_tic',
                'control_theme',
                'control_webarchive',
                'control_dmoz',
                'control_top_100',
                'control_yca',
                'control_whois',
                'control_yandex_blogs',
        );
    }


    public function setFillSitesValuesFlag()
    {
        // Ставим флаг о необходимости заполнения sites_values
        $sql = "INSERT INTO " .self::getExportFullTablename('control_settings') ." (`name`, `value`) VALUES ('fill_sites_values','1') ON DUPLICATE KEY UPDATE value = 1";
        self::$exportDb->exec($sql);
    }
}



/**********************************************************/
/**********************************************************/
/**********************************************************/
/**********************************************************/
/**********************************************************/



class ImportPositionModel extends ImportModel
{

    public function __construct($dbImport, $dbExport)
    {
        parent::__construct($dbImport, $dbExport);
        $needTables = self::getAllPositionImportTablesWitoutPref();
        $this->checkExistsTables($needTables, self::IMPORT_DB_ID);
        $needTables = self::getAllPositionExportTablesWitoutPref();
        $this->checkExistsTables($needTables, self::EXPORT_DB_ID);
    }

    public static function isPositionAlredyImport()
    {
        if ( isset($_SESSION['position_alredy_import']) && $_SESSION['position_alredy_import']===true ) 
            return true;
        else
            return false;
    }


    /**
     * Экспорт групп запросов
     */
    public function exportQueriesGroups($oldGroups)
    {
        $values = array();
        foreach ($oldGroups as $row)
        {
            if ( !is_array($row))
                continue;       
            $values = array_merge($values,array(array('id'=>$row["id"], 'name'=>$row["querygroup"])));
        }
        if ( !empty($values))
        {
            $sql = $this->getMultiInsertCommand('position_groups', array('id'=>'i','name'=>'s'), $values);
            $this->runMultiInsertCommand($sql);
        }
    }

    /**
     * Экспорт запросов и связей
     */
    public function exportQueries($oldQueries)
    {
        $values = array();
        foreach ($oldQueries as $row)
        {
            if ( !is_array($row))
                continue;
            $values = array_merge($values,array(array(
                                                      'id'=>$row["id"],
                                                      'name'=>$row["query"],
                                                      'group_id'=>$row["querygroup"],
                                                      'site_id'=>$row["siteid"],
                                                      'goal'=>$row["goal"],
                                                      'url'=>$row["relurl"],
                                                     )
            ));
        }
        if ( !empty($values))
        {
            $sql = $this->getMultiInsertCommand('position_queries', array('id'=>'i','name'=>'s','group_id'=>'i','site_id'=>'i','goal'=>'i','url'=>'s'), $values);
            $this->runMultiInsertCommand($sql);
        }
    }

    
    public function exportDynamicPos($oldSome, $newTableName)
    {
        $values = array();
        foreach ($oldSome as $row)
        {
            if ( !is_array($row))
                continue;
            // Для правки странной структуры старой БД
            if ($row["link"]=='none')
                $row["link"] = null;
            $values = array_merge($values,array(array(
                                                      'query_id'=>$row["phraseid"],
                                                      'value'=>$row["value"],
                                                      'url'=>$row["link"],
                                                      'date'=>$row["date"],
                                                      'region_id'=>$row["reg"],
                                                      'wsregion_id'=>$row["regid"],
                                                      'zone_id'=>$row["zone_id"]>0 ? $row["zone_id"] : 'NULL',
                                                      'language_id'=>$row["language_id"]>0 ? $row["language_id"] : 'NULL',
                                                      'region'=>isset($row["regionName"]) ? $row["regionName"] : NULL,
                                                     )
            ));
        }
        if ( !empty($values))
        {
            if ($newTableName=='position_yandex')
                $sql = $this->getMultiInsertCommand($newTableName, array('query_id'=>'i','value'=>'i','url'=>'s','date'=>'s','region_id'=>'i'), $values);
            elseif ($newTableName=='position_google') {
                $sql = $this->getMultiInsertCommand($newTableName, array('query_id'=>'i','value'=>'i','url'=>'s','date'=>'s','zone_id'=>'i','language_id'=>'i','region'=>'s'), $values);
            }
            elseif ($newTableName=='position_bing')
                $sql = $this->getMultiInsertCommand($newTableName, array('query_id'=>'i','value'=>'i','url'=>'s','date'=>'s'), $values);
            elseif ($newTableName=='position_wordstat_yandex')
            {
                foreach ($values as &$row)
                    $row['region_id'] = $row['wsregion_id'];
                unset($row);
                $sql = $this->getMultiInsertCommand($newTableName, array('query_id'=>'i','value'=>'i','date'=>'s','region_id'=>'i'), $values);
            }

            $this->runMultiInsertCommand($sql);
        }
    }


    private function getAllPositionImportTablesWitoutPref()
    {
        return array(
            'querygroup',
            'querysite',
            'ypos',
            'gpos',
            'bpos',
            'wspos',
        );
    }


    public static function getAllPositionExportTablesWitoutPref()
    {
        return array(
                'position_groups',
                'position_queries',
                'position_yandex',
                'position_google',
                'position_bing',
                'position_wordstat_yandex',
        );
    }


    public function getGoogleSiteRegRow($id)
    {
        $sql = "SELECT * FROM " .self::getImportFullTablename('sitereg') . " WHERE id = " . (int)$id;
        try
        {
            return self::$importDb->query($sql);
        }
        catch(PDOException $exc)
        {
            $excText = $exc->getMessage();
            $this->isErrors = true;
            $this->printErrorsInLogFile($sql, $exc, true);
        }        
    }

}

/**********************************************************/
/**********************************************************/
/**********************************************************/
/**********************************************************/
/**********************************************************/

class BaseController
{
    /**
     * Импорт групп сайтов
     */
    protected function importExportGroups()
    {
        $oldVGroups = $this->model->importSome('group');
        $this->model->exportGroups($oldVGroups);
    }


    /**
     * Импорт сайтов и связи с группами
     */
    protected function importExportSites()
    {
        $oldVSites = $this->model->importSome('site');
        $this->model->exportSites($oldVSites);
    }
}




class ImportPositionController extends BaseController
{
    CONST GOOGLE_ALIAS = 'google';
    CONST YANDEX_ALIAS = 'yandex';


    protected $model;

    protected $messages = array();

    public function __construct(ImportPositionModel $model)
    {
        $this->model = $model;
    }

    public function getMessages()
    {
        return $this->messages;
    }

    public function import()
    {
        if ($this->model->isConnectionErrors() || !$this->model->isModuleInstallInExportDb('position'))
            return false;

        if ($this->model->needWriteToCommonTablesExportDb())
        {
            $this->importExportGroups();
            $this->importExportSites();
            $writeToCommonTables = true;
        }
        $this->importExportQueriesGroups();
        $this->importExportQueries();
        $this->importExportYandexPos();
        $this->importExportGooglePos();
        $this->importExportBingPos();
        $this->importExportWordstatPos();

        if ($this->model->isErrors)
            return false;
        else
        {
            // Открываем сайты админу
            $this->model->setSumrForAdmin('position');
            $this->messages[] = array('type' => 'success', 'text' => 'Данные модуля Позиции успешно импортированы.');            

            if (isset($writeToCommonTables) && $writeToCommonTables===true)
            {
                // Записываем в сессию, что импортировали общие данные                
                $_SESSION['common_alredy_import'] = true;
            }
            $_SESSION['position_alredy_import'] = true;

            return true;
        }
    }


    /**
     * Импорт групп запросов
     */
    protected function importExportQueriesGroups()
    {
        $oldVQueriesGroups = $this->model->importSome('querygroup');
        $this->model->exportQueriesGroups($oldVQueriesGroups);
    }


    /**
     * Импорт запросов
     */
    protected function importExportQueries()
    {
        $chunk = 0;
        do
        {
            $oldVQueries = $this->model->importSomeWithOffset('querysite',$chunk)->fetchAll();
            $this->model->exportQueries($oldVQueries);
            $chunk++;
        } while ( !empty($oldVQueries));
    }


    protected function importExportYandexPos()
    {
        $chunk = 0;
        do
        {
            $oldVYandexPos = $this->model->importSomeWithOffset('ypos',$chunk)->fetchAll(PDO::FETCH_ASSOC);
            $this->model->exportDynamicPos($oldVYandexPos,'position_yandex');
            $chunk++;
        } while ( !empty($oldVYandexPos));

        // $oldVYandexPos = $this->model->importSome('ypos');
        // // Разбиваем на куски
        // $arr = array_chunk($oldVYandexPos->fetchAll(), 100);
        // foreach ($arr as $chunk)
        // {
        //     $this->model->exportDynamicPos($chunk,'position_yandex');
        // }
    }


    protected function importExportGooglePos()
    {
        $chunk = 0;
        do
        {
            $oldVGooglePos = $this->model->importSomeWithOffset('gpos',$chunk)->fetchAll(PDO::FETCH_ASSOC);
            $this->convertGoogleRegions($oldVGooglePos);
            $this->model->exportDynamicPos($oldVGooglePos,'position_google');
            $chunk++;
        } while ( !empty($oldVGooglePos));
    }


    protected function convertGoogleRegions(&$rows)
    {
        // Конвертируем для каждой строки регион
        foreach ($rows as &$row)
        {
            if ($row['reg']>0) {
                // $regId = $row['reg'];
                // Получаем зону и регион из таблицы sitereg
                $this->getGoogleZoneAndLanguage($row);
                $row['regionName'] = $this->getYandexRegionById($row['region_id']);
            }
        }
        unset($row);
    }


    protected function getYandexRegionById($id)
    {
        static $regions = array();
        static $regName = array();
        if (empty($regions)) {
            $regions = $this->model->importYandexRegionsFromExportDB()->fetchAll(PDO::FETCH_ASSOC);
            // Формируем массив: id=>имя
            if (count($regions)>0) {
                foreach ($regions as $region) {
                    $regionId = $region['id'];
                    $regName[$regionId] = $region['name'];
                }
            }
        }
        if (array_key_exists($id, $regName))
            return $regName[$id];
        else
            return null;
    }


    /**
     * из таблицы sitereg
     */
    protected function getGoogleZoneAndLanguage(&$row)
    {
        // Чтобы потом решить проблемы с FK
        $row['region_id'] = $row['zone_id'] = $row['language_id'] = 0;
        if (!isset($row['reg']) || $row['reg']<=0)
            return;
        else
            $regId = $row['reg'];
        // Строки по siteId
        static $siteRegRows = array();
        if ( !isset($siteRegRows[$regId]))
        {
            // Получаем строку
            $siteRegRows[$regId] = $this->model->getGoogleSiteRegRow($regId)->fetchAll(PDO::FETCH_ASSOC);
        }
        if (isset($siteRegRows[$regId][0]['regid']) && isset($siteRegRows[$regId][0]['zone']) && isset($siteRegRows[$regId][0]['lang']))
        {
            $row['region_id'] = $siteRegRows[$regId][0]['regid'];
            $row['zone_id'] = $siteRegRows[$regId][0]['zone'];
            $row['language_id'] = $siteRegRows[$regId][0]['lang'];
        }
    }



    // protected function getGoogleZoneIdByYandexRegionId($id)
    // {
    //     static $regions = array();
    //     static $regZone = array();
    //     if (empty($regions)) {
    //         $regions = $this->model->importYandexRegionsFromExportDB()->fetchAll(PDO::FETCH_ASSOC);
    //         // Формируем два массива: id=>имя и id=>zone
    //         if (count($regions)>0) {
    //             foreach ($regions as $region) {
    //                 $regionId = $region['id'];
    //                 $regZone[$regionId] = $region['zone'];
    //             }
    //         }
    //     }
    //     // Получили зоны Яндекса, теперь перевод в Гугл
    //     if (array_key_exists($id, $regZone)) {
    //         $yandexZoneName = $regZone[$id];
    //         switch ($yandexZoneName) {
    //             case 'ru':
    //                 return 1;
    //             case 'ua':
    //                 return 2;
    //             case 'by':
    //                 return 4;
    //             case 'kz':
    //                 return 5;
    //         }
    //     }

    //     return null;
    // }


    protected function importExportBingPos()
    {
        $oldVBingPos = $this->model->importSome('bpos');
        $this->model->exportDynamicPos($oldVBingPos,'position_bing');
    }


    protected function importExportWordstatPos()
    {
        $chunk = 0;
        do
        {
            $oldVWordstatPos = $this->model->importSomeWithOffset('wspos',$chunk)->fetchAll();
            $this->model->exportDynamicPos($oldVWordstatPos,'position_wordstat_yandex');
            $chunk++;
        } while ( !empty($oldVWordstatPos));

        // $oldVWordstatPos = $this->model->importSome('wspos');
        // $this->model->exportDynamicPos($oldVWordstatPos,'position_wordstat_yandex');
    }


    /**
     * Импортируем профили
     */
    protected function importExportProfiles()
    {
        // $oldVRegions = $this->model->importSome('sitereg');

        // // Настройки профилей для сайтов
        // $sitesSettings = array();
        // $i=0;
        // foreach ($oldVRegions as $row)
        // {
        //     $sitesSettings[$i]['site_id'] = $row['siteid'];
        //     if ($row['pos']=='yandex')
        //     {
        //         $sitesSettings[$i]['alias'] = self::YANDEX_ALIAS;
        //         $sitesSettings[$i]['yandexRegion'] = $row['regid'];
        //     }
        //     elseif ($row['pos']=='google')
        //     {
        //         $sitesSettings[$i]['alias'] = self::GOOGLE_ALIAS;
        //         $sitesSettings[$i]['googleZone'] = $row['zone'];
        //         $sitesSettings[$i]['googleLanguage'] = $row['lang'];
        //     }
        //     $i++;
        // }
    }
}


/**********************************************************/
/**********************************************************/
/**********************************************************/
/**********************************************************/
/**********************************************************/

class ImportControlController extends BaseController
{
    protected $model;

    protected $messages = array();

    public function __construct(ImportControlModel $model)
    {
        $this->model = $model;
    }

    public function getMessages()
    {
        return $this->messages;
    }

    public function import()
    {
        if ($this->model->isConnectionErrors() || !$this->model->isModuleInstallInExportDb('control'))
            return false;

        if ($this->model->needWriteToCommonTablesExportDb())
        {
            $this->importExportGroups();
            $this->importExportSites();
            $writeToCommonTables = true;
        }
        $this->importExportBing();
        $this->importExportGoogle();
        $this->importExportYandex();
        $this->importExportPR();
        $this->importExportTIC();
        $this->importExportTheme();
        $this->importExportWebArchive();
        $this->importExportDMOZ();
        $this->importExportRamblerTop100();
        $this->importExportYCA();
        $this->importExportWHOIS();
        // $this->importExportYandexBlogs();

        if ($this->model->isErrors)
            return false;
        else
        {
            // Открываем сайты админу
            $this->model->setSumrForAdmin('control');
            $this->messages[] = array('type' => 'success', 'text' => 'Данные модуля Контроль успешно импортированы.<br/>'
                // ВНИМАНИЕ! При переходе в модуль импортированные данные сразу Вы не увидите. Они появятся спустя некоторое время (около 30 минут), т.к. необходима их обработка.'
            );

            if (isset($writeToCommonTables) && $writeToCommonTables===true)
            {
                // Записываем в сессию, что импортировали общие данные                
                $_SESSION['common_alredy_import'] = true;
            }
            $_SESSION['control_alredy_import'] = true;
            $this->model->setFillSitesValuesFlag();

            return true;
        }
    }


    /**
     * Импорт BING
     */
    protected function importExportBing()
    {
        if ($this->model->doPaidTablesImport())
        {
            $old = $this->model->importSome('bp');
            $this->model->exportDynamic($old, 'control_bing');
        }
    }


    /**
     * Импорт Google
     */
    protected function importExportGoogle()
    {
        if ($this->model->doFreeImport())
        {
            $old = $this->model->importSome('freegp');
            $this->model->exportDynamic($old, 'control_google');
        }
        if ($this->model->doPaidTablesImport())
        {
            $chunk = 0;
            do
            {
                $old = $this->model->importSomeWithOffset('gp',$chunk)->fetchAll();
                $this->model->exportDynamic($old, 'control_google');
                $chunk++;
            } while ( !empty($old));
        }
    }


    /**
     * Импорт Yandex
     */
    protected function importExportYandex()
    {
        if ($this->model->doFreeImport())
        {
            $old = $this->model->importSome('freeyp');
            $this->model->exportDynamic($old, 'control_yandex');
        }
        if ($this->model->doPaidTablesImport())
        {
            $chunk = 0;
            do
            {
                $old = $this->model->importSomeWithOffset('yp',$chunk)->fetchAll();
                $this->model->exportDynamic($old, 'control_yandex');
                $chunk++;
            } while ( !empty($old));
        }
    }


    /**
     * Импорт PR
     */
    protected function importExportPR()
    {
        if ($this->model->doFreeImport())
        {
            $old = $this->model->importSome('freepr');
            $this->model->exportDynamic($old, 'control_pr');
        }
        if ($this->model->doPaidTablesImport())
        {
            $old = $this->model->importSome('pr');
            $this->model->exportDynamic($old, 'control_pr');
        }
    }

    /**
     * Импорт ТИЦ
     */
    protected function importExportTIC()
    {
        if ($this->model->doFreeImport())
        {
            $old = $this->model->importSome('freetic');
            $this->model->exportDynamic($old, 'control_tic');
        }
        if ($this->model->doPaidTablesImport())
        {
            $old = $this->model->importSome('tic');
            $this->model->exportDynamic($old, 'control_tic');
        }
    }


    /**
     * Импорт Тематика
     */
    protected function importExportTheme()
    {
        if ($this->model->doPaidTablesImport())
        {
            $old = $this->model->importSome('tematic');
            $this->model->exportDynamic($old, 'control_theme');
        }
    }


    /**
     * Импорт Вебархив
     */
    protected function importExportWebArchive()
    {
        if ($this->model->doPaidTablesImport())
        {
            // Проверим дополнительные таблицы
            if ( !$this->model->doImportWebArchive)
                return;
            $old = $this->model->importSome('control_f1');
            $this->model->exportDynamic($old, 'control_webarchive');
        }
    }


    /**
     * Импорт каталога DMOZ
     */
    protected function importExportDMOZ()
    {
        if ($this->model->doFreeImport())
        {
            $old = $this->model->importSome('freedmoz');
            $this->model->exportDynamic($old, 'control_dmoz');
        }
        if ($this->model->doPaidTablesImport())
        {
            $old = $this->model->importSome('dmoz');
            $this->model->exportDynamic($old, 'control_dmoz');
        }
    }

    /**
     * Импорт каталога Rambler TOP 100
     */
    protected function importExportRamblerTop100()
    {
        if ($this->model->doFreeImport())
        {
            $old = $this->model->importSome('freetop100');
            $this->model->exportDynamic($old, 'control_top_100');
        }
        if ($this->model->doPaidTablesImport())
        {
            $old = $this->model->importSome('top100');
            $this->model->exportDynamic($old, 'control_top_100');
        }
    }


    /**
     * Импорт YCA
     */
    protected function importExportYCA()
    {
        if ($this->model->doFreeImport())
        {
            $old = $this->model->importSome('freeyca');
            $this->model->exportDynamic($old, 'control_yca');
        }
        if ($this->model->doPaidTablesImport())
        {
            $old = $this->model->importSome('yca');
            $this->model->exportDynamic($old, 'control_yca');
        }
    }


    /**
     * Импорт
     */
    protected function importExportWHOIS()
    {
        if ($this->model->doPaidTablesImport())
        {
            $olddns = $this->model->importSome('dns');
            $oldcreated = $this->model->importSome('create');
            $oldexpired1 = $this->model->importSome('expire');
            if ($this->model->doFreeImport())
            {        
                $oldexpired2 = $this->model->importSome('freeexpire');
                $oldexpired = array_merge($oldexpired1->fetchAll(),$oldexpired2->fetchAll());
            }
            else
                $oldexpired = $oldexpired1->fetchAll();
                  
            // Исключаем повторы
            $dns = array(); $created = array(); $expired = array();
            $ex = array('olddns'=>'dns','oldcreated'=>'created','oldexpired'=>'expired');
            foreach ($ex as $oldName=>$newName)
            {
                foreach ($$oldName as $row)
                {
                    $siteId = $row['siteid'];
                    if ( !isset(${$newName}[$siteId]))
                    {
                        ${$newName}[$siteId] = $row;
                    }
                    else
                    {
                        if (${$newName}[$siteId]['date']<$row['date'])
                            ${$newName}[$siteId] = $row;    
                    }
                }
            }

            // Формируем массив
            $allSites =$this->model->importSome('site');
            $values = array();
            foreach ($allSites as $key=>$row)
            {
                $siteId = $row['id'];
                if (array_key_exists($siteId, $dns) || array_key_exists($siteId, $created) || array_key_exists($siteId, $expired))
                {
                    $values[$key]['site_id'] = $siteId;
                    if (array_key_exists($siteId, $dns))
                        $values[$key]['control_dns'] = $dns[$siteId]['value'];

                    if (array_key_exists($siteId, $created))
                        $values[$key]['control_created_date'] = $created[$siteId]['value'];
                    else
                        $values[$key]['control_created_date'] = "0000-00-00";

                    if (array_key_exists($siteId, $expired))
                        $values[$key]['control_expired_date'] = $expired[$siteId]['value'];
                    else
                        $values[$key]['control_expired_date'] = "0000-00-00";
                }
            }
            $this->model->exportWHOIS($values);
        }
    }

    
    /**
     * Импорт Yandex Blogs
     */
    protected function importExportYandexBlogs()
    {
        // if ($this->model->doPaidTablesImport())
        // {
        //     // Проверим дополнительные таблицы
        //     if ( !$this->model->doImportYandexBlogs)
        //         return;

        //     $auth = $this->model->importSome('control_f2')->fetchAll();
        //     $position = $this->model->importSome('control_f3')->fetchAll();
        //     $readers = $this->model->importSome('control_f4')->fetchAll();

        //     $values = array();
        //     // Объединяем массивы в один
        //     foreach ($auth as $key=>$rowAuth)
        //     {
        //         $dateParse = substr($rowAuth['date'],0,10);
        //         $values[$key]['site_id'] = $rowAuth['siteid'];
        //         $values[$key]['date'] = $dateParse;

        //         $rowPos = $position[$key];
        //         $rowReaders = $readers[$key];
        //         $values[$key]['control_yandex_blogs_auth'] = $rowAuth['value'];
        //         if ( $rowAuth['siteid']==$rowPos['siteid'] && $dateParse===substr($rowPos['date'],0,10) )
        //             $values[$key]['control_yandex_blogs_pos'] = $rowPos['value'];
        //         else
        //             return;
        //             // exit("Ошибка при экспорте Яндекс Блогов N1!");
        //         if ( $rowAuth['siteid']==$rowReaders['siteid'] && $dateParse===substr($rowReaders['date'],0,10) )
        //             $values[$key]['control_yandex_blogs_read'] = $rowReaders['value'];
        //         else
        //             return;
        //             // exit("Ошибка при экспорте Яндекс Блогов N2!");
        //     }
        //     // $this->model->exportYandexBlogs($values);
        // }
    }
}







